	SUBROUTINE DELMSH(IQPNT)
**************************************************************
*    The symmetry analysis of the mesh in k-space for        *
*    given set of the perturbation wave vectors q,i.e        * 
*    solution of the equation :                              *
*    ^              ^              ^                         *
*    G k + q + GG = G' k'  , where G is a group operation    *
*    k,k' and q are the wave vectors in irreducible wedge of *
*    Brillouin zone,GG is the reciprocal lattice vector      *
*    reduced into BZ if necessary.                           *
*    Written by S.Yu.Savrasov (P.N.Lebedev Physical Instit.) *
**************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER  IG0IG1(KMAX,NOPRMAX),IK0IK1(KMAX,NOPRMAX) 
     &   ,KVEC(3,0:NVCMAX),KQG(3,NOPRMAX),IKOV(NOPRMAX)
     &   ,IPQ(0:50,0:50,0:50),IGQ(0:50,0:50,0:50)
     &   ,IGS(0:50,0:50,0:50),IREF(0:NVCMAX)
     &   ,ISG(NOPRMAX,NOPRMAX),MSYMPN(NOPRMAX,KMAX)
     &   ,KSYMPN(NOPRMAX,KMAX),KCUT(3,4,6),NDIV(3)
	DIMENSION PNT(3,KMAX),QPNT(3),RBAS(3,3),GBAS(3,3)
     &   ,QB(3,3),RB(3,3),GVEC(3,0:NVCMAX),TU(3)
	COMPLEX*16U(NWIGMAX,48)
	LOGICAL FIRST
	COMMON /LATTICE/  RBAS,GBAS,QB,RB                      !!! from init
	COMMON /QMESH/    NQPNT,QPNT                           !!! from init
	COMMON /MESH/     NPNT,PNT                             !!! from ttrmsh
	COMMON /WMESH/    KCUT,IPQ,IGQ                         !!! from bzmesh
	COMMON /INVERS/   INV,IKOV                             !!! from group
	COMMON /INTTR/    NDIV                                 !!! from init
	COMMON /GROUPOUT/ NGROUP,U                             !!! from group
	COMMON /SUBGROUP/ NSGQ,NGEQ,ISG,KSYMPN,MSYMPN,IGS      !!! from symmsh
	COMMON /SYMMESH/  IG0IG1,IK0IK1                        !!! from symmsh
	COMMON /UNIT/     IUN                                  !!! from init
	DATA FIRST/.TRUE./,PI/3.141592653589793D0/,TU/0.D0,0.D0,0.D0/
C  SET DIVISIONS ALONG X,Y,Z
	N1=NDIV(1)
	N2=NDIV(2)
	N3=NDIV(3)
C  ROTATE Q-VECTOR BY RECIPROCAL SYMMETRY OPERATIONS
	DO 10 IR=1,NGROUP                               !!! over group
	IG=IKOV(IR)
	CALL ROTATE(QPNT(1),QPNT(2),QPNT(3),Q1,Q2,Q3,
     &  U(2,IG),1)
	X1=Q1*RB(1,1)+Q2*RB(2,1)+Q3*RB(3,1)
	X2=Q1*RB(1,2)+Q2*RB(2,2)+Q3*RB(3,2)
	X3=Q1*RB(1,3)+Q2*RB(2,3)+Q3*RB(3,3)
	J1=ANINT(X1)
	J2=ANINT(X2)
	J3=ANINT(X3)
C  CHECK WHETHER THE Q-VECTOR IS IN THE MESH
	IF(ABS(X1-J1).GE.1.D-05.OR.ABS(X2-J2).GE.1.D-05.OR.ABS(X3-J3).
     &  GE.1.D-05)STOP'<DELMSH>: Q-COORDINATES ARE NOT INTEGER'
	KQG(1,IR)=J1
	KQG(2,IR)=J2
	KQG(3,IR)=J3
  10    CONTINUE                                       !!! over group
C  DEFINE # OF ELEMENTS IN Q-STAR
	NSGQ=0
	NGEQ=0
	DO 60 IR=1,NGROUP
	NEC=1
	DO 30 ISGQ=1,NSGQ
	DO 20 IGEQ=1,NGEQ
	IF(ISG(IGEQ,ISGQ).EQ.IR)NEC=0
  20    CONTINUE
  30    CONTINUE
	IF(NEC.EQ.1)THEN
	NSGQ=NSGQ+1
	NGEQ=0
	DO 50 IR1=IR,NGROUP                            !!! over group
	NEQ=0
	DO 40 I=1,3
	IF(KQG(I,IR).EQ.KQG(I,IR1))NEQ=NEQ+1
  40    CONTINUE
	IF(NEQ.EQ.3)THEN
	NGEQ=NGEQ+1
	ISG(NGEQ,NSGQ)=IR1
	ENDIF
  50    CONTINUE                                       !!! over group
	ENDIF
  60    CONTINUE
	WRITE(IUN,1010)(QPNT(I),I=1,3)
	WRITE(IUN,1020) NGEQ
	WRITE(IUN,1030) NSGQ
C  FIND SPHERE RADIUS CIRCUMSCRIBING BZ+Q
	RMAX=0.D0
	DO 75 IZ=-1,1
	DO 75 JZ=-1,1
	DO 75 KZ=-1,1
	RSUM=0.D0
	DO 70 I=1,3
	RSUM=RSUM+(IZ*QB(I,1)*N1+JZ*QB(I,2)*N2+KZ*QB(I,3)*N3)**2
  70    CONTINUE
	RMAX=MAX(RMAX,RSUM)
  75    CONTINUE
	RMAX=1.5D0*SQRT(RMAX)+SQRT(QPNT(1)**2+QPNT(2)**2+
     &  QPNT(3)**2)+0.1D0
C  GENERATE ALL RECIPROCAL LATTICE VECTORS INSIDE SPHERE "RMAX"
	CALL SITEGEN(RMAX,GBAS(1,1),GBAS(1,2),GBAS(1,3),TU,1,NVEC,
     &  GVEC,IREF)
	NVEC=NVEC-1
	DO 80 IVEC=0,NVEC                               !!! over str.vectors
	KVEC(1,IVEC)=ANINT(GVEC(1,IVEC)*RB(1,1)+GVEC(2,IVEC)*RB(2,1)+
     &  GVEC(3,IVEC)*RB(3,1))
	KVEC(2,IVEC)=ANINT(GVEC(1,IVEC)*RB(1,2)+GVEC(2,IVEC)*RB(2,2)+
     &  GVEC(3,IVEC)*RB(3,2))
	KVEC(3,IVEC)=ANINT(GVEC(1,IVEC)*RB(1,3)+GVEC(2,IVEC)*RB(2,3)+
     &  GVEC(3,IVEC)*RB(3,3))
  80    CONTINUE                                        !!! over str.vectors
C  SET SYMMETRY INDICATOR ARRAY TO ZERO
	DO 90 I3=0,N3
	DO 90 I2=0,N2
	DO 90 I1=0,N1
	IGS(I1,I2,I3)=0
  90    CONTINUE
C  SET POINT SYMMETRY ARRAYS TO ZERO
	DO 100 IPNT=1,NPNT
	DO 100 ISGQ=1,NSGQ
	KSYMPN(ISGQ,IPNT)=0
	MSYMPN(ISGQ,IPNT)=0
 100    CONTINUE
C  DO OVER ALL POINTS OF THE BRILLOUIN ZONE AND MAKE ANALYSIS OF
C  THE MESH WITH RESPECT TO THE SYMMETRY OF THE PERTURBATION VECTOR
	DO 160 IPNT=1,NPNT
	DO 150 ISGQ=1,NSGQ
	KE1=0
	KE2=0
	DO 140 IGEQ=1,NGEQ
	IR=ISG(IGEQ,ISGQ)
	IG=IKOV(IR)
C  ROTATE K-VECTOR BY SYMMETRY OPERATION
	CALL ROTATE(PNT(1,IPNT),PNT(2,IPNT),PNT(3,IPNT),
     &  X1,X2,X3,U(2,IG),2)
	I1=ANINT(X1*RB(1,1)+X2*RB(2,1)+X3*RB(3,1))
	I2=ANINT(X1*RB(1,2)+X2*RB(2,2)+X3*RB(3,2))
	I3=ANINT(X1*RB(1,3)+X2*RB(2,3)+X3*RB(3,3))
C  ADD WAVEVECTOR OF THE PERTURBATION "Q"
	J1=I1+KQG(1,1)
	J2=I2+KQG(2,1)
	J3=I3+KQG(3,1)
C  REDUCE TO THE BRILLOUIN ZONE POINT (J1,J2,J3) WHICH IS "IG*IPNT+Q"
	NRED=0
	DO 110 IVEC=0,NVEC
	K1=J1+KVEC(1,IVEC)
	K2=J2+KVEC(2,IVEC)
	K3=J3+KVEC(3,IVEC)
	IF((K1.GE.0.AND.K1.LE.N1).AND.(K2.GE.0.AND.K2.LE.N2).
     &  AND.(K3.GE.0.AND.K3.LE.N3))THEN
C  THE POINT IS REDUCED TO THE BRILLOUIN ZONE
	NRED=NRED+1
C  THE SOLUTION G*K+Q+GG=G'*K'+GG' IS GIVEN BY
	IK0IK1(IPNT,IR)=IPQ(K1,K2,K3)
	IG0IG1(IPNT,IR)=IGQ(K1,K2,K3)
	IF(NRED.GT.8)STOP'<DELMSH>: # OF REDUCED POINTS IS TOO LARGE'
	GOTO 120
	ENDIF
 110    CONTINUE
	IF(NRED.EQ.0)STOP'<BZMESH>: THE POINT IS NOT REDUCED'
C  REDUCE TO THE BRILLOUIN ZONE POINT (I1,I2,I3) WHICH IS "IG*IPNT"
 120    NRED=0
	DO 130 IVEC=0,NVEC
	K1=I1+KVEC(1,IVEC)
	K2=I2+KVEC(2,IVEC)
	K3=I3+KVEC(3,IVEC)
	IF((K1.GE.0.AND.K1.LE.N1).AND.(K2.GE.0.AND.K2.LE.N2).
     &  AND.(K3.GE.0.AND.K3.LE.N3))THEN
C  THE POINT IS REDUCED TO THE BRILLOUIN ZONE, SET IGS-ARRAY
	NRED=NRED+1
	IF(IGS(K1,K2,K3).EQ.0)THEN
	KE1=ISGQ
	IGS(K1,K2,K3)=ISGQ
	ELSEIF(IGS(K1,K2,K3).NE.0)THEN
	KE2=-IGS(K1,K2,K3)
	ENDIF
	ENDIF
 130    CONTINUE
 140    CONTINUE                                          !!! over operations
	IF(KE1.NE.0.AND.(KE2.EQ.0.OR.-KE2.EQ.KE1))THEN
	KSYMPN(ISGQ,IPNT)=KE1
	MSYMPN(ISGQ,IPNT)=1
	ELSEIF(KE1.EQ.0.AND.KE2.NE.0)THEN
	KSYMPN(ISGQ,IPNT)=KE2
	MSYMPN(-KE2,IPNT)=MSYMPN(-KE2,IPNT)+1
	ELSEIF(KE1.NE.0.AND.KE2.NE.0.AND.-KE2.NE.KE1)THEN
	STOP'<SYMMSH>: CROSSING IS NOT ASSUMED'
	ENDIF
 150    CONTINUE                                          !!! over operations
 160    CONTINUE                                          !!! over k-points
1010    FORMAT(1X,'Symmetry analysis for q = (',G11.4,',',G11.4,','
     & ,G11.4,')')
1020    FORMAT(1X,'1) group of q-vector contains ',I2,' elements')
1030    FORMAT(1X,'2) star  of q-vector contains ',I2,' elements')
	END
