	  FUNCTION DET(A, MX, NX)
	  IMPLICIT REAL*8 (A-H,O-Z)
          DIMENSION A(MX*NX)
C
C         NOTE THAT A IS A TWO-DIMENSIONAL ARRAY OF M ROWS IN THE
C         CALLING PROGRAM.  THUS,
C         A(IK) IS A(I,K) PROVIDED IK = I + M*(K-1)
C
          M   =  MX
          N   =  NX
          N1  =  N - 1
          DET =  1
          IF(N1 .LE. 0)  GO TO 7
C
C         THE MATRIX IS TRIANGULARIZED, WITH ZEROES IN THE FIRST N1
C         COLUMNS BELOW THE MAIN DIAGONAL.
C
          DO  6     I  =  1, N1
C
C         THE PIVOT IS FOUND IN ROW I@  I.E. COLUMN L IS DETERMINED
C         SUCH THAT  /A(I,L)/ = MAX(/A(I,K)/@ K = I, I+1, ..., N)
C
          II  =  I + M*(I-1)
          P   =  ABS(A(II))
          L   =  I
          I1  =  I + 1
C
C         NOTE THAT FOR  K = I1  WE HAVE
          IK  =  I + M*(I1-1)
C         AND THAT IK WILL INCREASE BY M AS K INCREASES BY 1.
C
          DO  1     K  =  I1, N
                    IF(ABS(A(IK)) .LE. P)  GO TO 1
                    P  =  ABS(A(IK))
                    L  =  K
    1               IK  =  IK + M
C
C         IF THE PIVOT IS ZERO THEN THE MATRIX IS SINGULAR AND THE
C         EVALUATION PROCESS STOPS.
C
          IF(P .EQ. 0)  GO TO 8
C
C         IF  L .NE. I  THEN COLUMNS I AND L ARE INTERCHANGED
C         (FROM ROW I DOWNWARD)  AND THE SIGN OF DET CHANGED
C         ACCORDINGLY.
C
          IF(L .EQ. I)  GO TO 3
          DET  =  - DET
C
C         FOR  J = I  WE HAVE
          JI  =  II
          JL  =  I + M*(L-1)
C         AND JI AN JL WILL INCREASE BY 1 AS J INCREASES BY 1.
C
          DO  2     J  =  I, N
                    OLDAJI  =  A(JI)
                    A(JI)   =  A(JL)
                    A(JL)   =  OLDAJI
                    JI      =  JI + 1
                    JL      =  JL + 1
    2               CONTINUE
C
    3     DET  =  A(II) * DET
C
C         USING
C
          R  =  1. / A(II)
C         WE SUBTRACT FROM ROW J
          DO  5     J  =  I1, N
C
C                   THE A(J,I)/A(I,I)-FOLD OF ROW I (FROM COLUMN I1
C                   ONWARDS)
C
                    JI  =  J + M*(I-1)
                    Q   =  - A(JI) * R
C                   FOR  K = I1 WE HAVE
                    IK  =  I + M*(I1-1)
C                   JK  =  J + M*(I1-1)   OR
                    JK  =  IK + J - I
C
C                   AND WHENEVER K INCREASES BY 1 THEN IK AND JK
C                   WILL INCREASE BY M.  THUS,
C
                    DO  4     K  =  I1, N
                              A(JK) =  A(JK) + Q*A(IK)
                              IK    =  IK + M
                              JK    =  JK + M
    4                         CONTINUE
    5               CONTINUE
C
    6     CONTINUE
    7     NN  =  N + M*(N-1)
          DET =  A(NN) * DET
          RETURN
C
    8     DET  =  0.
          RETURN
      END
