	SUBROUTINE SEPIBND(IQPNT)
***********************************************************
*  Calculate electron-phonon interaction matrix elements. *
*  Written by S.Yu.Savrasov in Max-Planck-Institute, FRG. *
***********************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER ILST(NSORTMAX),ILSB(NSORTMAX),ILSW(NSORTMAX)
     &   ,IATS(NPAT,NPANMAX),ISTS(NSORTMAX,NPANMAX),NKAP(NPANMAX)
     &   ,NBNDF(NPANMAX),NBNDE(NPANMAX),NBNDT(NPANMAX)
     &   ,IKOV(NOPRMAX),ISG(NOPRMAX,NOPRMAX),IS(NPAT)
     &   ,KSYMPN(NOPRMAX,KMAX)
	COMPLEX*16 EPIMAT(-1:1,NPAT,-1:1,NPAT,4)
     &   ,VELMAT(-1:1,NPAT,-1:1,NPAT,4)
     &   ,EK(NKAPMAX,NPANMAX),EKAP(NKAPMAX,NPANMAX)
     &   ,DELH(NBNDMAX,NBNDMAX,-1:1,NPAT)
	DIMENSION PNT(3,KMAX),EARR(LIMZN,KMAX,NPANMAX)
     &   ,WEIGH(LIMZN,KMAX,NPANMAX),WEIGD(LIMZN,KMAX,NPANMAX)
     &   ,WEPI(NBNDMAX,NBNDMAX),WVEL(NBNDMAX,NBNDMAX,3)
	COMMON /CONTROL/LIFT,LMTO,NSPH,NINT,NPF,MODE           !!! from init
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSW,NATOM          !!! from init
	COMMON /MESH/   NPNT,PNT                               !!! from ttrmsh
	COMMON /ENERGY/ EARR,WEIGH,WEIGD                       !!! from delttr
	COMMON /KAPPAR/ NPAN,NKAP,EK,EKAP                      !!! from init
	COMMON /INVERS/ INV,IKOV                               !!! from group
	COMMON /SUBGROUP/NSGQ,NGEQ,ISG,KSYMPN                  !!! from symmsh
	COMMON /EPIMAT/ EPIMAT,VELMAT                          !!! from defbnd
	COMMON /NBANDS/ NBNDF,NBNDE,NBNDT                      !!! from init
	COMMON /WORD/   NVAL                                   !!! from nmtdata
	DATA PI/3.141592653589793D0/
C  SET EPI_MATRIX TO ZERO
	DO 10 INUC1=1,NATOM
	DO 10 INUC =1,NATOM
	DO 10 MY1=-1,1 
	DO 10 MY=-1,1
	DO 10 II=1,4
	EPIMAT(MY1,INUC1,MY,INUC,II)=(0.D0,0.D0)
	VELMAT(MY1,INUC1,MY,INUC,II)=(0.D0,0.D0)
  10	CONTINUE
C  INTEGRATE OVER BRILLOUIN ZONE
        DO 2000 ISGQ=1,NSGQ
        DO 1000 IPNT=1,NPNT
	IF(KSYMPN(ISGQ,IPNT).LT.0)GOTO1000
        IREC=1+IPNT+NPNT*(ISGQ-1)
C  READ EPI.MATRIX ELEMENTS
        READ(39,REC=IREC)
     &  ((WEPI(IBND,IBND1  ),IBND =1,NBNDF(1)-NBNDE(1)+1),
     &                       IBND1=1,NBNDF(1)-NBNDE(1)+1),
     &  ((WVEL(IBND,IBND1,1),IBND =1,NBNDF(1)-NBNDE(1)+1),
     &                       IBND1=1,NBNDF(1)-NBNDE(1)+1),
     &  ((WVEL(IBND,IBND1,2),IBND =1,NBNDF(1)-NBNDE(1)+1),
     &                       IBND1=1,NBNDF(1)-NBNDE(1)+1),
     &  ((WVEL(IBND,IBND1,3),IBND =1,NBNDF(1)-NBNDE(1)+1),
     &                       IBND1=1,NBNDF(1)-NBNDE(1)+1),
     &  ((((DELH(IBND,IBND1,MY,INUC),IBND=1,NBNDF(1)-NBNDE(1)+1),
     &  IBND1=1,NBNDF(1)-NBNDE(1)+1),MY=-1,1),INUC=1,NATOM)
C  CALCULATE CONTRIBUTION FROM A GIVEN K-POINT
	DO 70 INUC1=1,NATOM          !!! over displacements
	DO 60 INUC =1,NATOM          !!! over displacements
	DO 50 MY1=-1,1               !!! over polarizations
	DO 40 MY=-1,1                !!! over polarizations
	DO 30 IBNDC=1,NBNDF(1)-NBNDE(1)+1  ! over bands
	DO 20 IBNDC1=1,NBNDF(1)-NBNDE(1)+1 ! over bands
C TOTAL CONTRIBUTION TO THE HOPFIELD MATRIX
	EPIMAT(MY1,INUC1,MY,INUC,3)=
     &  EPIMAT(MY1,INUC1,MY,INUC,3)+DELH(IBNDC1,IBNDC,MY1,INUC1)*
     &  (-1)**MY*CONJG(DELH(IBNDC1,IBNDC,-MY,INUC))*
     &  WEPI(IBNDC,IBNDC1)
C TRANSPORT MATRICES V(kj)*V(kj) (1); V(k+qj')*V(k+qj') (2); V(kj)*V(k+qj') (3)
	VELMAT(MY1,INUC1,MY,INUC,1)=
     &  VELMAT(MY1,INUC1,MY,INUC,1)+DELH(IBNDC1,IBNDC,MY1,INUC1)*
     &  (-1)**MY*CONJG(DELH(IBNDC1,IBNDC,-MY,INUC))*
     &  WVEL(IBNDC,IBNDC1,1)
	VELMAT(MY1,INUC1,MY,INUC,2)=
     &  VELMAT(MY1,INUC1,MY,INUC,2)+DELH(IBNDC1,IBNDC,MY1,INUC1)*
     &  (-1)**MY*CONJG(DELH(IBNDC1,IBNDC,-MY,INUC))*
     &  WVEL(IBNDC,IBNDC1,2)
	VELMAT(MY1,INUC1,MY,INUC,3)=
     &  VELMAT(MY1,INUC1,MY,INUC,3)+DELH(IBNDC1,IBNDC,MY1,INUC1)*
     &  (-1)**MY*CONJG(DELH(IBNDC1,IBNDC,-MY,INUC))*
     &  WVEL(IBNDC,IBNDC1,3)
  20    CONTINUE                     !!! over bands
  30    CONTINUE                     !!! over bands
  40    CONTINUE                     !!! over polarizations
  50    CONTINUE                     !!! over polarizations
  60    CONTINUE                     !!! over displacements
  70    CONTINUE                     !!! over displacements
1000	CONTINUE                     !!! over k-points
2000	CONTINUE                     !!! over star of q-vector
	RETURN
	END
