      SUBROUTINE SBZMESH(NDIV)
**************************************************************
*  Divides the reciprocal lattice into microcells            *
*  Written by P.Bloechl in MPI, Germany                      *
**************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER IKOV(NOPRMAX),NDIV(3),IPQ(0:50,0:50,0:50)
     &   ,KVEC(3,0:NVCMAX),IGQ(0:50,0:50,0:50),IREF(0:NVCMAX)
     &   ,IBTR(3,3),KCUT(3,4,6),IMC(0:1,0:1,0:1),KTT(4)
	DIMENSION RB(3,3),QB(3,3),WGT(KMAX),V(3),V1(3),TU(3)
     &   ,RBAS(3,3),GBAS(3,3),PNT(3,KMAX),QB1(3,3)
     &   ,GVEC(3,0:NVCMAX)
	COMPLEX*16 U(NWIGMAX,48)
	COMMON /LATTICE/  RBAS,GBAS,QB,RB                     !!! from init
	COMMON /INVERS/   INV,IKOV                            !!! from group
	COMMON /MESH/     NPNT,PNT,WGT                        !!! from bzmesh
	COMMON /WMESH/    KCUT,IPQ,IGQ                        !!! from bzmesh
	COMMON /GROUPOUT/ NGROUP,U                            !!! from group
	DATA PI/3.141592653589793D0/,TU/0.D0,0.D0,0.D0/
C  SET DIVISIONS ALONG X,Y,Z
	N1=NDIV(1)
	N2=NDIV(2)
	N3=NDIV(3)
C  FIND SPHERE RADIUS CIRCUMSCRIBING BZ
	RMAX=0.D0
	DO 15 IZ=-1,1
	DO 15 JZ=-1,1
	DO 15 KZ=-1,1
	RSUM=0.D0
	DO 10 I=1,3
	RSUM=RSUM+(IZ*QB(I,1)*N1+JZ*QB(I,2)*N2+KZ*QB(I,3)*N3)**2
  10    CONTINUE
	RMAX=MAX(RMAX,RSUM)
  15    CONTINUE
	RMAX=1.5D0*SQRT(RMAX)+0.1D0
C  GENERATE ALL RECIPROCAL LATTICE VECTORS INSIDE SPHERE "RMAX"
	CALL SITEGEN(RMAX,GBAS(1,1),GBAS(1,2),GBAS(1,3),TU,1,NVEC,
     &  GVEC,IREF)
	NVEC=NVEC-1
	DO 20 IVEC=0,NVEC
	X1=GVEC(1,IVEC)*RB(1,1)+GVEC(2,IVEC)*RB(2,1)+
     &  GVEC(3,IVEC)*RB(3,1)
	X2=GVEC(1,IVEC)*RB(1,2)+GVEC(2,IVEC)*RB(2,2)+
     &  GVEC(3,IVEC)*RB(3,2)
	X3=GVEC(1,IVEC)*RB(1,3)+GVEC(2,IVEC)*RB(2,3)+
     &  GVEC(3,IVEC)*RB(3,3)
	KVEC(1,IVEC)=ANINT(X1)
	KVEC(2,IVEC)=ANINT(X2)
	KVEC(3,IVEC)=ANINT(X3)
	IF(ABS(KVEC(1,IVEC)-X1).GE.1.D-05.OR.
     &  ABS(KVEC(2,IVEC)-X2).GE.1.D-05.OR.
     &  ABS(KVEC(3,IVEC)-X3).GE.1.D-05)STOP'<BZMESH>: 
     &  ERROR IN RECIPROCAL LATTICE VECTORS'
  20    CONTINUE
C  INITIALIZE POINT-INDICATOR ARRAY
	DO 30 I3=0,N3
	DO 30 I2=0,N2
	DO 30 I1=0,N1
	IGQ(I1,I2,I3)=0
  30    IPQ(I1,I2,I3)=0
C  *** FIND UNEQUIVALENT K-POINTS IN WHOLE BZ ***
	NPNT=0
	NWGT=0
C  DO OVER WHOLE BRILOUIN ZONE
	DO 70 I3=0,N3
	DO 70 I2=0,N2
	DO 70 I1=0,N1
	IF(IPQ(I1,I2,I3).EQ.0)THEN
	V(1)=I1*QB(1,1)+I2*QB(1,2)+I3*QB(1,3)
	V(2)=I1*QB(2,1)+I2*QB(2,2)+I3*QB(2,3)
	V(3)=I1*QB(3,1)+I2*QB(3,2)+I3*QB(3,3)
	IWGT=0
C  ROTATE GIVEN POINT
	DO 60 IR=1,NGROUP
	IG=IKOV(IR)
	CALL ROTATE(V(1),V(2),V(3),V1(1),V1(2),V1(3),U(2,IG),2)
        X1=V1(1)*RB(1,1)+V1(2)*RB(2,1)+V1(3)*RB(3,1)
        X2=V1(1)*RB(1,2)+V1(2)*RB(2,2)+V1(3)*RB(3,2)
        X3=V1(1)*RB(1,3)+V1(2)*RB(2,3)+V1(3)*RB(3,3)
        J1=ANINT(X1)
        J2=ANINT(X2)
        J3=ANINT(X3)
C  CHECK WHETHER THE Q-VECTOR IS ON THE GRID
        IF(ABS(X1-J1).GE.1.D-03.OR.ABS(X2-J2).GE.1.D-03.OR.ABS(X3-J3).
     &  GE.1.D-03)STOP'<TETRA>: K-COORDINATES ARE NOT INTEGER'
C  REDUCE THE POINT TO THE BRILLOUIN ZONE
	NRED=0
	DO 40 IVEC=0,NVEC
	K1=J1+KVEC(1,IVEC)
	K2=J2+KVEC(2,IVEC)
	K3=J3+KVEC(3,IVEC)
	IF((K1.GE.0.AND.K1.LE.N1).AND.(K2.GE.0.AND.K2.LE.N2).
     &  AND.(K3.GE.0.AND.K3.LE.N3))THEN
C  THE POINT IS REDUCED TO THE BRILLOUIN ZONE BY VECTOR IVEC
	NRED=NRED+1
	IF(NRED.GT.8)STOP'<BZMESH>: # OF REDUCED POINTS IS TOO LARGE'
	IF(IGQ(K1,K2,K3).EQ.0)IGQ(K1,K2,K3)=IR
	IF(IPQ(K1,K2,K3).EQ.0)IWGT=IWGT+1
	IPQ(K1,K2,K3)=NPNT+1
	ENDIF
  40    CONTINUE
	IF(NRED.EQ.0)STOP'<BZMESH>: THE POINT IS NOT REDUCED'
  60    CONTINUE
	NPNT=NPNT+1
	IF(NPNT.GT.KMAX)STOP'<BZMESH>: # OF K-POINTS > KMAX'
	PNT(1,NPNT)=V(1)
	PNT(2,NPNT)=V(2)
	PNT(3,NPNT)=V(3)
	WGT(NPNT)=0.D0
	NWGT=NWGT+IWGT
	ENDIF
  70    CONTINUE
	IF(NWGT.NE.(N1+1)*(N2+1)*(N3+1))STOP'<TETRA>: ERROR IN POINTS'
C  *** FIND UNEQUIVALENT TETRAHEDRA AND COUNT THEM ***
	CALL CCUTUP(QB,QB1,IBTR,KCUT)
C  START LOOPING OVER MICROCELLS
        OT=1.D0/DBLE(N1*N2*N3)/6.D0         !!! volume of tetrahedron
	VOLIBZ=1.D0
	DO 140 I3=0,N3-1
	DO 140 I2=0,N2-1
	DO 140 I1=0,N1-1
C  SET UP TETRAHEDRA INSIDE MICROCELL
        DO 130 ITTR=1,6                     !!! over tetrahedra
        DO 110 I=1,4
C  COORDINATES OF THE TETRAHEDRON AGE GIVEN BY KTT
        J1=I1+KCUT(1,I,ITTR)
        J2=I2+KCUT(2,I,ITTR)
        J3=I3+KCUT(3,I,ITTR)
        KTT(I)=IPQ(J1,J2,J3)
 110	CONTINUE
        DO 120 I=1,4
        WGT(KTT(I))=WGT(KTT(I))+OT/4.D0     !!! geometrical weight f(kj)=1
 120    CONTINUE
 130	CONTINUE
 140	CONTINUE
C  NORMALIZATION
	DO 150 IPNT=1,NPNT
	WGT(IPNT)=WGT(IPNT)/VOLIBZ*2.D0
 150	CONTINUE
	END




        SUBROUTINE REDFCEL(X,AD,RD,NDIV,NR)
*********************************************************
*  Finds coordinates of vector X in the first cell      *
*  defined by Ad*Ndiv. Rd - reciprocals to Ad.          *
*********************************************************
        IMPLICIT REAL*8 (A-H,O-Z)
        INTEGER NDIV(3),NR(3)
        DIMENSION X(3),AD(3,3),RD(3,3)
        X1=X(1)*RD(1,1)+X(2)*RD(2,1)+X(3)*RD(3,1)
        X2=X(1)*RD(1,2)+X(2)*RD(2,2)+X(3)*RD(3,2)
        X3=X(1)*RD(1,3)+X(2)*RD(2,3)+X(3)*RD(3,3)
        N1=ANINT(X1)
        N2=ANINT(X2)
        N3=ANINT(X3)
        IF(ABS(N1-X1).GE.1.D-05.OR.ABS(N2-X2).GE.1.D-05.
     &  OR.ABS(N3-X3).GE.1.D-05)STOP'<REDFCEL>:: WRONG POINT !'
        NR(1)=MOD(N1,NDIV(1))
        NR(2)=MOD(N2,NDIV(2))
        NR(3)=MOD(N3,NDIV(3))
        IF(NR(1).LT.0)NR(1)=NR(1)+NDIV(1)
        IF(NR(2).LT.0)NR(2)=NR(2)+NDIV(2)
        IF(NR(3).LT.0)NR(3)=NR(3)+NDIV(3)
        END



      SUBROUTINE CCUTUP(B0,B,IBTR,KCUT)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION B(3,3),IBTR(3,3),B0(3,3),KCUT0(3,4,6),KCUT(3,4,6),
     .   SHIFT(3),P(3,4)
      DATA KCUT0/
     .  0,0,0, 0,1,0, 1,1,0, 1,1,1,  0,0,0, 1,0,0, 1,1,0, 1,1,1,
     .  0,0,0, 1,0,0, 1,0,1, 1,1,1,  0,0,0, 0,1,0, 0,1,1, 1,1,1,
     .  0,0,0, 0,0,1, 0,1,1, 1,1,1,  0,0,0, 0,0,1, 1,0,1, 1,1,1 /
      DATA SHIFT/0.D0,0.D0,0.D0/
      ANRM2(X,Y,Z)=X*X*1.00001D0+Y*Y*1.00002D0+Z*Z*1.00003D0
     .  -X*0.000004D0-Y*0.000003D0-Z*0.000002D0
C ------ CALL CSHEAR TO GET MOST COMPACT CELL (doesn't work) --------
      CALL CSHEAR(B0,B,IBTR)
C ----- CHOSE CUTUP WITH SHORTEST MAX EDGE ---------
      LZ = 0
      LXX = 0
      LYY = 0
      EDGMAX = 1.D20
      EDGMIN = 0.D0
      DO  10  LX = 0, 1
	DO  10  LY = 0, 1
	DO  12  ITET = 1, 6
	  DO  12  IC = 1, 4
   12   CALL MXMYMZ(KCUT0(1,IC,ITET),KCUT(1,IC,ITET),LX,LY,LZ)
	EDMIN = 1D20
	EDMAX = 0D0
	DO  20  ITET = 1, 6
	  DO  21  IC = 1, 4
   21     CALL GTBVEC(KCUT(1,IC,ITET),B,SHIFT,P(1,IC))
	  DO  13  I = 1, 3
	    DO  13  J = I+1, 4
	    XX = ANRM2(P(1,I)-P(1,J),P(2,I)-P(2,J),P(3,I)-P(3,J))
	    EDMAX = DMAX1(EDMAX,XX)
	    EDMIN = DMIN1(EDMIN,XX)
   13     continue
   20   CONTINUE
	IF (EDMAX .LT. EDGMAX) THEN
	  LXX = LX
	  LYY = LY
	  EDGMAX = EDMAX
	  EDGMIN = EDMIN
	ENDIF
   10 CONTINUE
      DO  22  ITET = 1, 6
	DO  22  IC = 1, 4
   22 CALL MXMYMZ(KCUT0(1,IC,ITET),KCUT(1,IC,ITET),LXX,LYY,LZ)
      END


      SUBROUTINE GTBVEC(K,B,SHIFT,V)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION K(3),V(3),B(3,3),SHIFT(3)
      V(1) = SHIFT(1) + K(1)*B(1,1) + K(2)*B(1,2) + K(3)*B(1,3)
      V(2) = SHIFT(2) + K(1)*B(2,1) + K(2)*B(2,2) + K(3)*B(2,3)
      V(3) = SHIFT(3) + K(1)*B(3,1) + K(2)*B(3,2) + K(3)*B(3,3)
      RETURN
      END


      SUBROUTINE MXMYMZ(KIN,K,LX,LY,LZ)
C- Do mirrors in x,y,z if lx,ly,lz=1, respectively
C ----------------------------------------------------------------
Ci Inputs
Ci
Co Outputs
Co
Cr Remarks
Cr
C ----------------------------------------------------------------
      DIMENSION KIN(3),K(3)
      K(1) = KIN(1)
      K(2) = KIN(2)
      K(3) = KIN(3)
      IF (LX .EQ. 1) K(1) = 1-K(1)
      IF (LY .EQ. 1) K(2) = 1-K(2)
      IF (LZ .EQ. 1) K(3) = 1-K(3)
      RETURN
      END

      SUBROUTINE CSHEAR(B0,B,IBTR)
C- Tries to make microcell more compart by shearing.
C ----------------------------------------------------------------
Ci Inputs
Ci
Co Outputs
Co
Cr Remarks
Cr   Ibtr gives the transformation from bo to b.
C ----------------------------------------------------------------
C      implicit none
C Passed parameters
C Local parameters
      IMPLICIT double precision (A-H,O-Z)
      DIMENSION B(3,3),IBTR(3,3),B0(3,3)
      DO  8  I = 1, 3
	DO  7  J = 1, 3
	  B(J,I) = B0(J,I)
	  IBTR(J,I) = 0
    7   continue
	IBTR(I,I) = 1
    8 continue
      END
