	SUBROUTINE INIT
*************************************************************
*  Control module <INIT> for reading all the input data     *
*  Written by S.Yu.Savrasov in Max-Planck-Institute, FRG    *
*************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	CHARACTER INPFILE*60,DYNFILE*60
C  READ INPFILE-NAME
	PRINT1010
	READ(5,1030)INPFILE
	PRINT1020
	READ(5,1030)DYNFILE
C  READ DATA
	CALL READINP(INPFILE) !!! reads input control file
	CALL READDYN(DYNFILE) !!! reads input control file
	CALL QVECTOR
1010    FORMAT(1X,'INPFILE? ',$)
1020    FORMAT(1X,'DYNFILE? ',$)
1030    FORMAT(A)
	END




        SUBROUTINE READINP(INPFILE)
************************************************************
*  <READINI> reads control parameters,atomic stucture data *
*  iterative procedures limits and accuracy parameters     *
************************************************************
        IMPLICIT REAL*8 (A-H,O-Z)
        INCLUDE 'PARAM.DAT'
        INTEGER IS(NPAT),ILST(NSORTMAX),ILSB(NSORTMAX),NHSORT(NSORTMAX)
     &   ,NODES(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX),ILSV(NSORTMAX)
     &   ,ICOR(NSORTMAX),IATS(NPAT,NPANMAX),ISTS(NSORTMAX,NPANMAX)
     &   ,NKAP(NPANMAX),NBNDF(NPANMAX),NBNDE(NPANMAX),NBNDT(NPANMAX)
     &   ,NSEM(NSORTMAX),LBS(36,NSORTMAX),NDS(36,NSORTMAX),NDIV(3)
     &   ,MNY(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX),LR(NSORTMAX)
     &   ,ITS(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX),ISPL(NSORTMAX)
     &   ,NFFTG(3),NDIW(3),NQDIV(3)
        INTEGER LBROY(-1:1,NPAT),IBROY(-1:1,NPAT)
     &   ,NITER(-1:1,NPAT),KEY(-1:1,NPAT),KSP(-1:1,NPAT)
        DIMENSION SASA(NSORTMAX),AMASS(NSORTMAX),QPNT(3),SH(3)
     &   ,ENY(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &   ,DNY(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &   ,TNY(0:LMAXT,NSORTMAX,NKAPMAX,NPANMAX,NSPINMAX)
     &   ,Z(NSORTMAX),ZCORE(NSORTMAX),SMT(NSORTMAX),STRAIN(3,3,2)
     &   ,SPLIT(NSORTMAX),SROU(NSORTMAX),ORTH(2:3)
        DIMENSION EPS(-1:1,NPAT),ADMIXB(-1:1,NPAT),ADMIXH(-1:1,NPAT)
     &   ,ADMIX1(-1:1,NPAT),ADMIN(-1:1,NPAT),ADMAX(-1:1,NPAT)
     &   ,ADMSPN(-1:1,NPAT),ASMIN(-1:1,NPAT),ASMAX(-1:1,NPAT)
        COMPLEX*16 EK(NKAPMAX,NPANMAX),EKAP(NKAPMAX,NPANMAX)
     &   ,ESEM(36,NSORTMAX)
        CHARACTER*60 INPFILE,CONFILE,SRFFILE,KOVFILE,BNDFILE
     &   ,SCFFILE,STRFILE,PHNFILE,TMPFILE,OUTFILE,PNTFILE
     &   ,PSIFILE,ENRFILE,HUBFILE,SCRFILE(100)
        CHARACTER TEXT*64,TXT*72,TXTEL(NSORTMAX)*10,TEXQ*10
     &   ,TXTSP(2)*2,RS*10,RY*10
        LOGICAL LTPAN(0:LMAXT+1,NPAT,NKAPMAX,NPANMAX),EXIST
     &  ,LSPAN(0:LMAXT+1,NSORTMAX,NKAPMAX,NPANMAX)
C Controls:
        COMMON /CONTROL/ LIFT,LMTO,NSPH,NINT,NPF,MODE        !!! from init
        COMMON /PARAM/   NSORT,IS,ILST,ILSB,ILSV,NATOM,NHSORT!!! from init
        COMMON /PLZCOM/  NPLZ,LPLZ,IPLZ                      !!! from init
        COMMON /PHNCOM/  ITERMAX,NITER,EPS                   !!! from init
        COMMON /ORBS/    NORBS                               !!! from init
        COMMON /SPIN/    NSPIN,SPLIT,ISPL                    !!! from init
        COMMON /RELATIV/ LR                                  !!! from init
        COMMON /COR1/    ICOR                                !!! from init
        COMMON /RMTA/    IRMTA                               !!! from init
        COMMON /EXCH/    IEXCH,ICHUB                         !!! from init
C Inputs:
        COMMON /LATPAR/  PAR,ORTH,OMEGAC,STRAIN,VV0          !!! from init
        COMMON /KAPPAR/  NPAN,NKAP,EK,EKAP                   !!! from init
        COMMON /PANPAR/  LTPAN,LSPAN,IATS,ISTS               !!! from init
        COMMON /POTCOM/  SWZ,SMT                             !!! from inti
        COMMON /NBANDS/  NBNDF,NBNDE,NBNDT,POLUS             !!! from init
        COMMON /MASS/    AMASS                               !!! from init
        COMMON /MULTRO/  Z,ZCORE                             !!! from init
        COMMON /ASASPH/  SASA                                !!! from init
C Mixing:
        COMMON /MIXDRHO/ ADMIX1,ADMIN,ADMAX,KEY              !!! from init
        COMMON /MIXDMAG/ ADMSPN,ASMIN,ASMAX,KSP              !!! from init
        COMMON /MIXBROY/ LBROY,IBROY,ADMIXB,ADMIXH           !!! from init
C K-mesh:
        COMMON /QMESH/   NQPNT,QPNT,NUMQ,NQDIV,KEYQ          !!! from init
        COMMON /INTTR/   NDIV,NDIW,SH                        !!! from init
C Pot.pars:
        COMMON /INPPAR/  TNY,ENY,DNY,NODES,MNY               !!! from init
C Plane waves:
        COMMON /FFTMESH/ NFFTG                               !!! from init
        COMMON /TEILORG/ KEYT,BZM                            !!! from init
        COMMON /ACCURG/  EPSR,EPSG,ECUTG                     !!! from init
C Outputs:
        COMMON /OUT0EL/  SCRFILE,SCFFILE,STRFILE,PNTFILE,HUBFILE,OUTFILE
        COMMON /OUT1EL/  ICON,ISRF,IKOV,IBND,IPSI,IHBR,IOUT  !!! from init
        COMMON /OUT2EL/  CONFILE,SRFFILE,KOVFILE,BNDFILE,PSIFILE,ENRFILE
        COMMON /TEXT/    TEXT                                !!! from init
        COMMON /TXTEL/   TXTEL,TXTSP,TEXQ                    !!! from init
        COMMON /UNIT/    IUN                                 !!! from init
        DATA PI/3.141592653589793D0/
C--------------------------------------------
C***** INPUT FILE 1 FOR PHN-PACK ************
C--------------------------------------------
        OPEN(1,FILE=INPFILE,STATUS='OLD')
        READ(1,1000) TEXT
C    ****** CONTROL PARAMETERS : ******************
C    LIFT=1 - strmsh ; =2 + bands ; =3 + delstr; 4 + phonons scf-loop
C    LMTO=1 - standard LMTO, TB not assumed
C    NSPH   - empty
C    LPLZ=0 - without screening, =1 - with screening 4pi/q^2 singularity
C             >1 screening by calculating PI(q+G,q+G') matrix
C             lplz shows # of reciprocal coordination spheres
C    MODE=1 - full start, =2 - restart, =3 - restart with update
C        =4 - dynamical matrix, =5 - electron-phonon interaction
C        =51- rigid muffin-tin part of the electron-phonon interaction
        READ(1,1001)TXT
        READ(1,*)LIFT
        READ(1,*)LMTO
        READ(1,*)NSPH
        READ(1,*)LPLZ
        READ(1,*)MODE
C   *** CHECK OUT DIFFERENT MODES AND INTERNAL KEYS ***
C   SET RMTA-CASE FOR EPI-CALCULATION
        IF(MODE.NE.51)IRMTA=0
        IF(MODE.EQ.51)IRMTA=1
        IF(MODE.EQ.51)MODE=5
C   SET MODE FOR THE DYNAMICAL MATRIX
        IF(MODE.EQ.4)NPF=1 !!! full calculation
        IF(MODE.NE.4)NPF=0 !!! calculation of Hellman-Feynman contribution
C   OVERLAP MATRIX IS ALWAYS VIA S-DOT!
        NINT=2
C   NEW SELF-CONSISTENCY SCHEME IS ALWAYS ON!
        NPLZ=1
C   ****** EXCHANGE-CORRELATION CODE ******
C    IEXCH=1 Barth-Hedin,2:Gun-Lun,3:Mor-Jan-Will,4:Vosko-Wilk,Nuss.
C          5:Perdew-Wang 1991, 6:Gaspar-Kohn-Sham
C    for IEXCH < 0 generalized gradient corrections after Perdew 1991
C    are included. The local potential is according to ABS(IEXCH)
C    ICHUB>0 Add Hubbard correction according to LDA+U method
C            A HUBFILE must be specified describing the correlated
C            states.
        READ(1,1000)TXT
        READ(1,*)IEXCH,ICHUB
        IF(IEXCH.LT.0)PRINT*,'<READINI>:: FOR GGA91 ONLY SPHERICAL
     &  PART OF THE TOTAL DENSITY IS TAKEN INTO ACCOUNT'
        IF(ICHUB.GT.0)THEN
        BACKSPACE(UNIT=1)
        READ(1,*)IEXCH,ICHUB,HUBFILE
        ENDIF
C   ****** ITERATIVE PROCEDURES LIMITS : ******
C   ITERMAX - Max.number of iterations in <Phonons>
C   ADMIX0  - Charge Density Admixture in <Phonons>
C   ADSPIN  - Magnetization  Admixture in <Phonons>
C   EPS     - Accuracy of the charge density
C   LBROY   - switch on Broyden mixing for Lbroy=0,1,... components
C   IBROY   - switch on Broyden mixing after N=IBROY iterations
C   ADMIXB  - Initial Broyden Jakobian
C   ADMIXH  - Mixing for high-l components of the density if
C            low-l components (.le lbroy) are mixed with Broyden
        READ(1,1000)TXT
        READ(1,*) ITERMAX,ADMIX0,ADSPIN0,EPS0
     &           ,LBROY0,IBROY0,ADMIXB0,ADMIXH0
C   KEY=0(1) - Admixture=ADMIX1(Admixture=1.D0) when iter=1
        KEY0=0
        KSP0=0
        IF(MODE.EQ.4.OR.MODE.EQ.5)ITERMAX=1
C   ********* ATOMIC DATA : *********
C   NATOM - number of atoms in unit-cell
C   NSORT - number of different types of atoms
C   NSPIN - number of spins
C   NORBS - 1/2 which switches off/on spin-orbit coupling
C   PAR   - lattice parameter, equillibrium volume ratio
C   IS(IATOM) - number of sort for each atom
C   NKAP  - number of tail for wave functions and their energies
        READ(1,1000) TXT
        READ(1,*)  NATOM,NSORT,NSPIN,NORBS
        IF(NATOM.GT.NPAT)STOP'<READINP>: "NPAT" MUST BE INCREASED
     &  IN PARAM.DAT'
        IF(NSORT.GT.NSORTMAX)STOP'<READINP>: "NSORTMAX" MUST BE
     &  INCREASED IN PARAM.DAT'
        IF(NSPIN.GT.NSPINMAX)STOP'<READINP>: # OF SPINS MISMATCHES,
     &  SET "NSPINMAX=2" IN PARAM.DAT'
        IF(NORBS.GT.NSPINMAX)STOP'<READINP>: TO SWITCH ON SO-COUPLING,
     &  SET "NSPINMAX=2" IN PARAM.DAT'
        IF(NSPIN.EQ.1.AND.NORBS.EQ.2)STOP'<READINP>: TO SWITCH SO-COUPLING,
     &  NSPIN MUST BE EQUAL 2'
        IF(NORBS.EQ.2)STOP'<SPIN-ORBIT COUPLING NOT READY!'
        READ(1,*)  PAR0,VV0
        READ(1,*) (IS(I),I=1,NATOM)
        READ(1,*)  NKAP(1),(EKAP(IKAP,1),IKAP=1,NKAP(1))
        IF(NKAP(1).GT.NKAPMAX)STOP'<READINP>: "NKAPMAX" MUST BE
     &  INCREASED IN PARAM.DAT'
        DO ISORT=1,NSORT               !!! over diff.types of atoms
C   ******* ATOMIC DATA : ***************************
C   ILST(ISORT) - lmax for trial function expansion
C   ILSB(ISORT) - lmax for basis set
C   ILSV(ISORT) - lmax for the potential
C   Z(ISORT) - nuclear charge
C   ZCORE(ISORT)- number of core electrons
C   LR(ISORT)   - 0/1 for non/semi relativistic version
C   ICOR(ISORT) - core renormalisation key
C   ISPL(ISORT) - 1 for permanent splitting (magnetic field)
C   SPLIT(ISORT)- splitting in case spin-polarisation
C   MASS(ISORT) - nuclear mass of the element
C   SMT(ISORT)  - mt-sphere radius
C   SROU(ISORT) - circumscribed sphere radius (does not use)
        READ(1,1000)TXTEL(ISORT)
        READ(1,*)Z(ISORT),ZCORE(ISORT),LR(ISORT),ICOR(ISORT),
     &  ISPL(ISORT),SPLIT(ISORT),AMASS(ISORT)
        READ(1,*)SMT(ISORT),SROU(ISORT),SASA(ISORT)
        READ(1,*)ILST(ISORT),ILSB(ISORT),ILSV(ISORT)
        IF(ILST(ISORT).GT.LMAXT)STOP'<READINP> "LMAXT" MUST BE
     &  INCREASED IN PARAM.DAT'
        IF(ILSB(ISORT).GT.LMAXB)STOP'<READINP> "LMAXB" MUST BE
     &  INCREASED IN PARAM.DAT'
        IF(ILSV(ISORT).GT.LMAXV)STOP'<READINP> "LMAXV" MUST BE
     &  INCREASED IN PARAM.DAT'
C   ******** ENY/DNY - STUFF : ***************
C   ENY(IKAP,L,ISORT) - initial Eny
C   DNY(IKAP,L,ISORT) - initial Dny
C   NODES(IKAP,L,ISORT) - number of zeroes for radial wave functions
        READ(1,1000)TXT
        DO IKAP=1,NKAP(1)
        READ(1,1000)TXT
        READ(1,*)(NODES(L,ISORT,IKAP,1),L=0,ILSB(ISORT))
        READ(1,*)(ITS  (L,ISORT,IKAP,1),L=0,ILSB(ISORT))
        READ(1,*)(MNY  (L,ISORT,IKAP,1),L=0,ILSB(ISORT))
        READ(1,*)(ENY  (L,ISORT,IKAP,1,1),L=0,ILSB(ISORT)),ENYUP
        READ(1,*)(DNY  (L,ISORT,IKAP,1,1),L=0,ILSB(ISORT))
        DO L=0,ILSB(ISORT)
        NODES(L,ISORT,IKAP,1)=NODES(L,ISORT,IKAP,1)-L-1
        ENY(L,ISORT,IKAP,1,NSPIN)=ENY(L,ISORT,IKAP,1,1)
        DNY(L,ISORT,IKAP,1,NSPIN)=DNY(L,ISORT,IKAP,1,1)
        ENDDO
        DO L=ILSB(ISORT)+1,ILST(ISORT)
        ENY(L,ISORT,IKAP,1,1)=ENYUP
        ENY(L,ISORT,IKAP,1,NSPIN)=ENYUP
        ENDDO
        ENDDO
        READ(1,1000)TXT
        READ(1,*)NSEM(ISORT)
        DO ISEM=1,NSEM(ISORT)
        READ(1,*)NDS(ISEM,ISORT),LBS(ISEM,ISORT),ESEM(ISEM,ISORT)
        NDS(ISEM,ISORT)=NDS(ISEM,ISORT)-LBS(ISEM,ISORT)-1
        ENDDO
        ENDDO                             !!! over diff.types of atoms
C   ****** INPUT-OUTPUT FILES FOR "ELECTRONS" *****
        READ(1,1000)TXT
        READ(1,*)ISCF,SCFFILE      !!! scf-density
        READ(1,*)ISTR,STRFILE      !!! structure information
        READ(1,*)IPNT,PNTFILE      !!! list of q-points
        READ(1,*)ISCR,SCRFILE(1)   !!! scratch storage
        READ(1,*)ICON,CONFILE      !!! structure constants
        READ(1,*)ISRF,SRFFILE      !!! surface constants
        READ(1,*)IENR,ENRFILE      !!! band structure for weights
        READ(1,*)IBND,BNDFILE      !!! band structure and
        READ(1,*)IPSI,PSIFILE      !!! wave functions
        READ(1,*)IOUT,OUTFILE      !!! current output
C   ***** OTHER DATA FOR PHN-PACK *****
C   NFF - number of fully filled bands
C   NEF - number of bands at Ef
C   NDIV - division of tetrahedra parameter (.ne.0)
C   NFFT(1..3) - fft-grid, must be even numbers
C   EPSR - Accuracy of pseudo-Hankel functions at the sphere
C   EPSG - Accuracy of Fourier transform for pseudo-Hankels
C   KEYT = 0 no Teilor for V_int, 1 to zero's order
C   BZM - radius of a sphere in units of the Brillouin zone for Teilor series
        READ(1,1000) TXT
        READ(1,*)  NFF,NEF,POLUS
        READ(1,*) (NDIV(I),I=1,3),(NDIW(I),I=1,3)
        READ(1,*) (NFFTG(I),I=1,3),EPSR,EPSG,KEYT,BZM
        CLOSE(1)
        IF(NFFTG(1).EQ.0)STOP'SET FFT-GRID IN INIFILE'
        IF(MOD(NFFTG(1),2).NE.0)STOP'FFT-GRID MUST BE EVEN'
        IF(MOD(NFFTG(2),2).NE.0)STOP'FFT-GRID MUST BE EVEN'
        IF(MOD(NFFTG(3),2).NE.0)STOP'FFT-GRID MUST BE EVEN'
        NBNDF(1)=NFF+NEF
        NBNDE(1)=NFF+1
        IF(NDIW(1)/NDIV(1).NE.ANINT(DBLE(NDIW(1)/NDIV(1))))
     &  STOP'<READINP>:: NDIW(1)/NDIV(1) MUST BE INTEGER'
        IF(NDIW(2)/NDIV(2).NE.ANINT(DBLE(NDIW(2)/NDIV(2))))
     &  STOP'<READINP>:: NDIW(1)/NDIV(1) MUST BE INTEGER'
        IF(NDIW(3)/NDIV(3).NE.ANINT(DBLE(NDIW(3)/NDIV(3))))
     &  STOP'<READINP>:: NDIW(1)/NDIV(1) MUST BE INTEGER'
        IF(NDIW(1)/NDIV(1).NE.NDIW(2)/NDIV(2).OR.NDIW(1)/NDIV(1).
     &  NE.NDIW(3)/NDIV(3).OR.NDIW(2)/NDIV(2).NE.NDIW(3)/NDIV(3))
     &  STOP'<READINP>: NDIW(I)/NDIV(I) MUST BE THE SAME FOR I=1,2,3'
        IF(NBNDF(1).GT.NDIMMAX)STOP'<READINI>: # OF FILLED BANDS
     &  MISMATCHES, INCREASE "NDIMMAX" IN PARAM.DAT'
        IF(NEF.GT.NBNDMAX)STOP'<READINI>: # OF CROSSSING BANDS
     &  MISMATCHES, INCREASE "NBNDMAX" IN PARAM.DAT'
        TXTSP(1)='up'
        TXTSP(2)='dn'
C  SET LATTICE PARAMETERS ACCORDING TO V/V0
        PAR=PAR0*VV0**0.333333333333333333D0
        DO ISORT=1,NSORT
        SMT(ISORT)=SMT(ISORT)*PAR/PAR0
        SROU(ISORT)=SROU(ISORT)*PAR/PAR0
        ENDDO
C SET # OF ATOMS FOR GIVEN SORT ARRAY
        DO ISORT=1,NSORT
        NHSORT(ISORT)=0
        DO IATOM=1,NATOM
        IF(IS(IATOM).EQ.ISORT)NHSORT(ISORT)=NHSORT(ISORT)+1
        ENDDO
        ENDDO
C  DEFINE MAIN VALENCE PANEL
        NBND=0
        DO IATOM=1,NATOM
        ISORT=IS(IATOM)
        I=0
        DO IKAP=1,NKAP(1)
        MAXLB=-1
        DO L=0,ILSB(ISORT)
        LTPAN(L,IATOM,IKAP,1)=.FALSE.
        LSPAN(L,ISORT,IKAP,1)=.FALSE.
        IF(ITS(L,ISORT,IKAP,1).EQ.1)THEN
        LTPAN(L,IATOM,IKAP,1)=.TRUE.
        LSPAN(L,ISORT,IKAP,1)=.TRUE.
        I=I+1
        NBND=NBND+2*L+1
        MAXLB=MAX(MAXLB,L)
        ENDIF
        ENDDO
        IF(MAXLB.GT.ILSB(ISORT)-1)THEN
        IF(DREAL(EKAP(IKAP,1)).LE.0.D0.AND.MODE.NE.4)PRINT*,
     &  'Set ILSB ',TXTEL(ISORT),' to ILSB+1, i.e. ',ILSB(ISORT)+1
        IF(DREAL(EKAP(IKAP,1)).LE.0.D0.AND.MODE.EQ.4)STOP
     &  '<READINP>:: SET ILSB TO ILSB+1 IN <INPFILE>'
        ENDIF
        DO L=ILSB(ISORT)+1,ILST(ISORT)
        LTPAN(L,IATOM,IKAP,1)=.FALSE.
        LSPAN(L,ISORT,IKAP,1)=.FALSE.
        MNY(L,ISORT,IKAP,1)=0
        ENDDO
        LTPAN(ILST(ISORT)+1,IATOM,IKAP,1)=.FALSE.
        LSPAN(ILST(ISORT)+1,ISORT,IKAP,1)=.FALSE.
        ENDDO
        IATS(IATOM,1)=0
        ISTS(ISORT,1)=0
        IF(I.NE.0)IATS(IATOM,1)=IATOM
        IF(I.NE.0)ISTS(ISORT,1)=ISORT
        ENDDO
        NBNDT(1)=NBND
C  DEFINE # OF SEMICORE PANELS AND ATOMS PARTICIPATING IN EACH PANEL
        IPAN=1
        DO IATOM=1,NATOM
        ISORT=IS(IATOM)
        DO ISEM=1,NSEM(ISORT)
        ILSB(ISORT)=MAX(ILSB(ISORT),LBS(ISEM,ISORT))
        I=0
        DO JPAN=2,IPAN
        IF(ESEM(ISEM,ISORT).NE.EKAP(1,JPAN))I=I+1
        ENDDO
        IF(I.EQ.IPAN-1)THEN
        IPAN=IPAN+1
        IF(IPAN.GT.NPANMAX)STOP'<READINP> NPANMAX MUST BE INCREASED
     &  IN PARAM.DAT'
        NKAP(IPAN)=1
        EKAP(1,IPAN)=ESEM(ISEM,ISORT)
        ENDIF
        ENDDO
        ENDDO
        NPAN=IPAN
        DO IPAN=2,NPAN
        NBND=0
        DO IATOM=1,NATOM
        ISORT=IS(IATOM)
        IATS(IATOM,IPAN)=0
        ISTS(ISORT,IPAN)=0
        DO L=0,ILST(ISORT)
        LSPAN(L,ISORT,1,IPAN)=.FALSE.
        LTPAN(L,IATOM,1,IPAN)=.FALSE.
        MNY(L,ISORT,1,IPAN)=0
        ENDDO
        LSPAN(ILST(ISORT)+1,ISORT,1,IPAN)=.FALSE.
        LTPAN(ILST(ISORT)+1,IATOM,1,IPAN)=.FALSE.
        DO ISEM=1,NSEM(ISORT)
        IF(ESEM(ISEM,ISORT).EQ.EKAP(1,IPAN))THEN
        L=LBS(ISEM,ISORT)
        IATS(IATOM,IPAN)=IATOM
        ISTS(ISORT,IPAN)=ISORT
        NBND=NBND+2*L+1
        LTPAN(L,IATOM,1,IPAN)=.TRUE.
        LSPAN(L,ISORT,1,IPAN)=.TRUE.
        MNY(L,ISORT,1,IPAN)=2
        NODES(L,ISORT,1,IPAN)=NDS(ISEM,ISORT)
        ENY(L,ISORT,1,IPAN,1)=EKAP(1,IPAN)
        ENY(L,ISORT,1,IPAN,NSPIN)=EKAP(1,IPAN)
        ENDIF
        ENDDO
        ENDDO
        NBNDF(IPAN)=NBND
        NBNDT(IPAN)=NBND
        NBNDE(IPAN)=NBND+1
        ENDDO
        DO IPAN=1,NPAN
        DO IKAP=1,NKAP(IPAN)
        EKAP(IKAP,IPAN)=EKAP(IKAP,IPAN)*PAR0**2/PAR**2
        EK(IKAP,IPAN)=EKAP(IKAP,IPAN)*PAR*PAR
        ENDDO
        ENDDO
C  SET SHIFT OF WHOLE BZ FROM HIGH-SYMMETRY POSITION
        SH(1)=0.D0
        SH(2)=0.D0
        SH(3)=0.D0
        IF(NBNDF(1)-NBNDE(1)+1.NE.0)THEN
        SH(1)=1.D-07
        SH(2)=2.D-07
        SH(3)=3.D-07
        ENDIF
C  SET MIXING ARRAYS
        DO INUC=1,NATOM
        DO MY=-1,1
        NITER(MY,INUC)=ITERMAX
        EPS  (MY,INUC)=EPS0
        KEY  (MY,INUC)=KEY0
        KSP  (MY,INUC)=KSP0
        LBROY(MY,INUC)=LBROY0
        IBROY(MY,INUC)=IBROY0
        ADMIX1(MY,INUC)=ADMIX0
        ADMSPN(MY,INUC)=ADSPIN0
        ADMIXB(MY,INUC)=ADMIXB0
        ADMIXH(MY,INUC)=ADMIXH0
        ENDDO
        ENDDO
C  STRUCTURE DATA
        INQUIRE(FILE=STRFILE,EXIST=EXIST)
        IF(.NOT.EXIST)
     &  STOP'<READINP>:: STRFILE MUST EXIST'
C  LIST OF Q-POINTS
        INQUIRE(FILE=PNTFILE,EXIST=EXIST)
        IF(.NOT.EXIST)
     &  STOP'<READINP>:: PNTFILE MUST EXIST'
C  OUTPUT CHANNEL
        IUN=6
1000    FORMAT(A)
1001    FORMAT(/A)
        END




	SUBROUTINE READDYN(DYNFILE)
************************************************************************
*  Reads dynamical matrix from standard output file.                   *
************************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER IS(NPAT),ILST(NSORTMAX),ILSB(NSORTMAX),NHSORT(NSORTMAX)
     &    ,ILSV(NSORTMAX)
        COMPLEX*16 DMAT(3,NPAT,3,NPAT,4)
	DIMENSION QPNTR(3)
        CHARACTER TEXT*17,DYNFILE*60
        LOGICAL EXIST
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM,NHSORT
        COMMON /DYNMAT/ DMAT
        INQUIRE(FILE=DYNFILE,EXIST=EXIST)
        IF(.NOT.EXIST)STOP'<READDYN>::DYNFILE MUST EXIST!'
        OPEN(1,FILE=DYNFILE,STATUS='OLD')
        DO 100 IL=1,2000000
        READ(1,1010)TEXT
1010    FORMAT(6X,A17)
        IF(TEXT.NE.'D Y N A M I C A L')GOTO100
        READ(1,1020)(QPNTR(I),I=1,3)
1020    FORMAT(12X,G11.4,1X,G11.4,1X,G11.4)
        DO INUC1=1,NATOM               !!! over nuclear shifts
        DO INUC=1,NATOM                !!! over nuclear shifts
        READ(1,1030)IATOM1,IATOM
1030    FORMAT(1X,16X,I2,1X,10X,6X,I2,1X,10X)
        IF(IATOM1.NE.INUC1)PRINT*,'IATOM1.NE.INUC1, SOMETHING WRONG!'
        IF(IATOM .NE.INUC )PRINT*,'IATOM .NE.INUC , SOMETHING WRONG!'
        READ(1,*)
        DO IXYZ1=1,3                  !!! over x,y,z
        READ(1,1040)(DMAT(IXYZ1,INUC1,IXYZ,INUC,1),IXYZ=1,3)
        ENDDO
1040    FORMAT(1X,2G11.4,1X,2G11.4,1X,2G11.4)
C  SKIP OTHER LINES
        DO IFORM=2,4
        READ(1,*)
        DO IXYZ1=1,3                  !!! over x,y,z
        READ(1,*)
        ENDDO
        ENDDO
        ENDDO                         !!! over nuclear shifts
        ENDDO                         !!! over nuclear shifts
	RETURN
 100    CONTINUE
	STOP'<READDYN>:: DYNFILE CANNOT BE READ!'
        END
