	SUBROUTINE SPECTRA(IQPNT)
************************************************************
*  Diagonalization of the dynamical matrix and calculation *
*  of the phonon frequences, polarizations.                *
*  Written by S.Yu.Savrasov in Max-Planck-Institute, FRG.  *
************************************************************
	INCLUDE 'PARAM.DAT'
	IMPLICIT REAL*8 (A-H,O-Z)
	INTEGER IS(NPAT),ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
	COMPLEX*16 DYNMAT(3,NPAT,3,NPAT,4),DPOL(3,NPAT,3*NPAT)
     &    ,HMAT(NDIMMAX*NSPINMAX,NDIMMAX*NSPINMAX)
     &    ,OMAT(NDIMMAX*NSPINMAX,NDIMMAX*NSPINMAX)
	DIMENSION AMASS(NSORTMAX),E(NDIMMAX*NSPINMAX),OM(3*NPAT)
        COMMON /CONTROL/LIFT,LMTO,NSPH,NINT,NPF,MODE        !!! from init
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM       !!! from init
        COMMON /OUT1PH/ IDSF,IDRO,IPHN,ITMP,IDV,IOUT,IWTH   !!! from init
        COMMON /DYNMAT/ DYNMAT,OM,DPOL,IFT                  !!! from dynmat
        COMMON /MASS/   AMASS                               !!! from init
	COMMON /STORE2/ HMAT,OMAT                           !!! tmp.storage
C  SET FORCE THEOREM
	IFT=1    !!! first force formula for dynamical matrix is used
C  MAKE MATRIX FOR DIAGONALIZATION
	IDIM1=0
	DO 40 INUC1=1,NATOM                      !!! over nuclear shifts
	DO 30 I=1,3                              !!! over x,y,z
	IDIM1=IDIM1+1
	IDIM=0
	DO 20 INUC=1,NATOM                       !!! over nuclear shifts
	DO 10 J=1,3                              !!! over x,y,z
	IDIM=IDIM+1
	AMS=1.D0/SQRT(AMASS(IS(INUC1))*AMASS(IS(INUC)))
	AMS=AMS*109.752                          !!! since Me=5.4876D-04 m.a.u.
	DMRE=DREAL(DYNMAT(I,INUC1,J,INUC,IFT))   !!! set up zeroes where necess.
	DMIM=DIMAG(DYNMAT(I,INUC1,J,INUC,IFT))
 	IF(ABS(DMRE).LE.1.D-05)DMRE=0.D0
 	IF(ABS(DMIM).LE.1.D-05)DMIM=0.D0
	IF(IDIM.EQ.IDIM1)DMIM=0.D0
	HMAT(IDIM1,IDIM)=DCMPLX(DMRE,DMIM)*AMS
	OMAT(IDIM1,IDIM)=(0.D0,0.D0)
	IF(IDIM1.EQ.IDIM)OMAT(IDIM1,IDIM)=(1.D0,0.D0)
  10    CONTINUE                                 !!! over x,y,z
  20    CONTINUE                                 !!! over nuclear shifts
  30    CONTINUE                                 !!! over x,y,z
  40    CONTINUE                                 !!! over nuclear shifts
C  SYMMETRIZE DYNAMICAL MATRIX, ENFORCE HERMITIANNESS
	DO 60 IDIM1=1,3*NATOM
	DO 50 IDIM=1,IDIM1
	DMRE10=+DREAL(HMAT(IDIM1,IDIM))
	DMRE01=+DREAL(HMAT(IDIM,IDIM1))
	DMRE=0.5D0*(DMRE10+DMRE01)
	DMIM10=+DIMAG(HMAT(IDIM1,IDIM))
	DMIM01=-DIMAG(HMAT(IDIM,IDIM1))
	DMIM=0.5D0*(DMIM10+DMIM01)
	HMAT(IDIM1,IDIM)=DCMPLX(DMRE,+DMIM)
	HMAT(IDIM,IDIM1)=DCMPLX(DMRE,-DMIM)
  50	CONTINUE
  60	CONTINUE
C  EIGENVALUE PROBLEM
	CALL EIGEN1A(3*NATOM,HMAT,OMAT,E,1,1,IERR)
C  FREQUENCES AND POLARIZATIONS
	DO 100 IOMG=1,3*NATOM                    !!! over phonon branches
        IF(E(IOMG).GE.0.D0)OM(IOMG)=+SQRT(E(IOMG))*
     &  13.6058D0*0.3162278D-02                  !!! units are eV
        IF(E(IOMG).LT.0.D0)OM(IOMG)=-SQRT(-E(IOMG))*
     &  13.6058D0*0.3162278D-02                  !!! units are eV
	IDIM=0
	DO 90 INUC=1,NATOM                       !!! over nuclear shifts
	DO 80 I=1,3                              !!! over x,y,z
	IDIM=IDIM+1
	DPOL(I,INUC,IOMG)=OMAT(IDIM,IOMG)
  80    CONTINUE                                 !!! over x,y,z
  90    CONTINUE                                 !!! over nuclear shifts
 100    CONTINUE                                 !!! over phonon branches
	END
