	SUBROUTINE ERRMSG(PROG,MNUM,ADDMES,TS)
*****************************************************
*  Gives error messages:                            *
*  TS='M' - Simple message.                         *
*  TS='W' - Warning message.                        *
*  TS='S' - Severe error, program terminated.       *
*****************************************************
	CHARACTER PROG*(*),FMES*14,ADDMES*(*),TS*1
	COMMON /UNIT/ IUN,IUT,IUR
C FIRST SENTENSE
	IF(TS.EQ.'S')FMES='Terminated in '
	IF(TS.EQ.'W')FMES='Warning  from '
	IF(TS.EQ.'M')FMES='Message  from '
	WRITE(IUT,1)FMES//'<'//PROG//'> ::'
    1	FORMAT(1X,A)
	WRITE(IUT,2)MNUM
    2	FORMAT(1X,'Message No.',I4)
C STANDARD ERROR MESSAGE
	IF(MNUM.EQ.1)THEN
	WRITE(IUT,1)ADDMES
	ENDIF
C SPECIAL ERROR MESSAGES
*************************************************************
C Messages from <readini>
	IF(PROG.EQ.'READINI')THEN
	IF(MNUM.EQ.11)THEN
	WRITE(IUT,11)
  11	FORMAT(
     &  'Generalized gradient approximation (GGA91) is only'/
     &  'avaiable for spherical part of  the density.  Full'/
     &  'GGA91 and GGA96 are not yet implemented.          ')
	ELSEIF(MNUM.EQ.12)THEN
  12	FORMAT(
     &  'The number of  filled bands for  the main  valence'/
     &  'panel calculated from the valence charge is larger'/
     &  'than the value read from INIFILE. Standard correc-'/
     &  'tion will be made. In the next execution check the'/
     &  'input values NFF and NEF in the INIFILE.          ')
	ENDIF 
	ENDIF
*************************************************************
C Messages from <readscf>
	IF(PROG.EQ.'READSCF')THEN
	IF(MNUM.EQ.21)THEN
	WRITE(IUT,21)
  21	FORMAT(
     &  'Number of atoms read from INIFILE and this value  '/
     &  'read from SCFFILE do not coincide. Check creation '/
     &  'of SCFFILE.                                       ')
	ELSEIF(MNUM.EQ.22)THEN
	WRITE(IUT,22)
  22	FORMAT(
     &  'Number of sorts read from INIFILE and this value  '/
     &  'read from SCFFILE do not coincide. Check creation '/
     &  'of SCFFILE.                                       ')
	ELSEIF(MNUM.EQ.23)THEN
	WRITE(IUT,23)
  23	FORMAT(
     &  'Number of spins read from SCFFILE is larger than  '/
     &  'the value NSPINMAX specified in PARAM.DAT. Incre- '/
     &  'NSPINMAX and recompile the program.               ')
	ELSEIF(MNUM.EQ.24)THEN
	WRITE(IUT,24)
  24	FORMAT(
     &  'Number of plane waves read from SCFFILE is larger '/
     &  'than the value NPLWMAX specified in PARAM.DAT.    '/
     &  'Increase NPLWMAX and recompile the program.       ')
	ELSEIF(MNUM.EQ.25)THEN
	WRITE(IUT,25)
  25	FORMAT(
     &  'Number of non-zero components for spherical harmo-'/
     &  'nics read from SCFFILE is larger than the value   '/
     &  'NSYMMAX specified in PARAM.DAT. Increase NSYMMAX  '/
     &  'and recompile the program.                        ')
	ELSEIF(MNUM.EQ.26)THEN
	WRITE(IUT,26)
  26	FORMAT(
     &  'Number of radial points read from SCFFILE is lar- '/
     &  'ger than the value NRADMAX specified in PARAM.DAT.'/
     &  'Increase NRADMAX and recompile the program.       ')
	ELSEIF(MNUM.EQ.27)THEN
	WRITE(IUT,27)
  27	FORMAT(
     &  'The version of SCFFILE read by this subroutine is '/
     &  'too old. The program will continue but there is no'/
     &  'garantee that the calculation will be correct.    ')
	ELSEIF(MNUM.EQ.28)THEN
	WRITE(IUT,28)
  28	FORMAT(
     &  'There was no restart information detected in SCF- '/
     &  'FILE. Most likely because it is just made using   '/
     &  '<MAKESCFM> utility.                               ')
	ELSEIF(MNUM.EQ.29)THEN
	WRITE(IUT,29)
  29	FORMAT(
     &  'SCFFILE contains both charge density and magnetiz-'/
     &  'ation while spin-restricted calculation is suppos-'/
     &  'ed to be performed.                               ')
	ELSEIF(MNUM.EQ.30)THEN
	WRITE(IUT,30)
  30	FORMAT(
     &  'The number of core electrons calculated according '/
     &  'to the input data of INIFILE is odd. Check INIFILE')
	ELSEIF(MNUM.EQ.31)THEN
	WRITE(IUT,31)
  31	FORMAT(
     &  'The number of core electrons has been changed.    '/
     &  'The Broyden mixing will start at second iteration.')
	ELSEIF(MNUM.EQ.32)THEN
	WRITE(IUT,32)ADDMES
  32	FORMAT(
     &  'The number of core electrons has been changed for ',A/
     &  'Therefore it is assumed that core renormalization '/
     &  'will be switched on.                              ')
	ENDIF
	ENDIF
*************************************************************
C Messages from <readstr>
C TERMINATE PROGRAM IF NECESSARY
	IF(TS.EQ.'S')STOP
	IF(TS.EQ.'W')CONTINUE
	IF(TS.EQ.'M')CONTINUE
	END
