	SUBROUTINE PLWMSH
***********************************************************
*  Generate vectors in reciprocal space for using in      *
*  fourier transform. S.Savrasov, Last revison 12.11.95.  *
***********************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER IS(NPAT),ILST(NSORTMAX),ILSB(NSORTMAX)
     &   ,INDG(NFFTMAX),KVEC(3,0:NPLWMAX),KGMIN(3),KGMAX(3)
     &   ,ILSV(NSORTMAX),NFFTG(3)
	DIMENSION RBAS(3,3),GBAS(3,3),TAU(3,NPAT),ORTH(2:3)
     &   ,GPLW(3,0:NPLWMAX),GL(3),TAU0(3),SMT(NSORTMAX)
     &   ,BET(0:LMAXV,NSORTMAX),GEQU(3,3),STRAIN(3,3,2)
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM         !!! from init
	COMMON /LATTICE/RBAS,GBAS                             !!! from init
        COMMON /MANSTR/ ISTRAIN                               !!! from init
	COMMON /BASIS/  TAU                                   !!! from init
	COMMON /POTCOM/ SWZ,SMT                               !!! from init
	COMMON /ACCURG/ EPSR,EPSG,ECUTG                       !!! from init
	COMMON /PLWMESH/NPLW,GPLW,KVEC,KGMIN,KGMAX,INDG       !!! from plwmsh
	COMMON /FFTMESH/NFFTG                                 !!! from init
	COMMON /BETPAR/ BET                                   !!! from plwmsh
	COMMON /LATPAR/ PAR,ORTH,OMEGAC,STRAIN                !!! from init
	COMMON /UNIT/   IUN                                   !!! from init
	COMMON /WORD/   NVAL                                  !!! from nmtdata
	DATA PI/3.141592653589793D0/,TAU0/0.D0,0.D0,0.D0/
C  SET RECIPROCAL LATTICE FOR THE CELL IN THE EQUILLIBRIUM
	IF(ISTRAIN.EQ.1)THEN
	DO 30 IVEC=1,3
	DO 20 I=1,3
	GEQU(I,IVEC)=0.D0
	DO 10 J=1,3
	GEQU(I,IVEC)=GEQU(I,IVEC)+GBAS(J,IVEC)*STRAIN(J,I,1)
  10	CONTINUE
  20	CONTINUE
  30	CONTINUE
	ELSEIF(ISTRAIN.NE.1)THEN
	DO 40 IVEC=1,3
	GEQU(1,IVEC)=GBAS(1,IVEC)
	GEQU(2,IVEC)=GBAS(2,IVEC)
	GEQU(3,IVEC)=GBAS(3,IVEC)
  40	CONTINUE
	ENDIF
C  SET RECIPROCAL-LATTICE GRID
	KGMIN(1)=-NFFTG(1)/2
	KGMAX(1)=+NFFTG(1)/2
	KGMIN(2)=-NFFTG(2)/2
	KGMAX(2)=+NFFTG(2)/2
	KGMIN(3)=-NFFTG(3)/2
	KGMAX(3)=+NFFTG(3)/2
C  DEFINE CUTOFF SPHERE IN RECIPROCAL SPACE
	SPHERE=1.D+14
	DO 140 I=1,3
	IF(I.EQ.1)THEN
	NSTEP1=KGMAX(1)-KGMIN(1)-2
	NSTEP2=1
	NSTEP3=1
	ENDIF
	IF(I.EQ.2)THEN
	NSTEP1=1
	NSTEP2=KGMAX(2)-KGMIN(2)-2
	NSTEP3=1
	ENDIF
	IF(I.EQ.3)THEN
	NSTEP1=1
	NSTEP2=1
	NSTEP3=KGMAX(3)-KGMIN(3)-2
	ENDIF
	DO 130 M3=KGMIN(3)+1,KGMAX(3)-1,NSTEP3
	DO 120 M2=KGMIN(2)+1,KGMAX(2)-1,NSTEP2
	DO 110 M1=KGMIN(1)+1,KGMAX(1)-1,NSTEP1
	GX=M1*GEQU(1,1)+M2*GEQU(1,2)+M3*GEQU(1,3)
	GY=M1*GEQU(2,1)+M2*GEQU(2,2)+M3*GEQU(2,3)
	GZ=M1*GEQU(3,1)+M2*GEQU(3,2)+M3*GEQU(3,3)
	ABSR=SQRT(GX**2+GY**2+GZ**2)
	SPHERE=MIN(SPHERE,ABSR)
 110	CONTINUE
 120	CONTINUE
 130	CONTINUE
 140	CONTINUE
	SPHERE=SPHERE+1.D-10
C  FIND VECTORS
	IPLW=-1
        M1MIN=KGMAX(1)
        M1MAX=KGMIN(1)
        M2MIN=KGMAX(2)
        M2MAX=KGMIN(2)
        M3MIN=KGMAX(3)
        M3MAX=KGMIN(3)
	DO 230 M3=KGMIN(3),KGMAX(3)
	DO 220 M2=KGMIN(2),KGMAX(2)
	DO 210 M1=KGMIN(1),KGMAX(1)
	GX=M1*GEQU(1,1)+M2*GEQU(1,2)+M3*GEQU(1,3)
	GY=M1*GEQU(2,1)+M2*GEQU(2,2)+M3*GEQU(2,3)
	GZ=M1*GEQU(3,1)+M2*GEQU(3,2)+M3*GEQU(3,3)
	ABSR=SQRT(GX**2+GY**2+GZ**2)
	IF(ABSR.LE.SPHERE)THEN
	IPLW=IPLW+1
	IF(IPLW.GT.NPLWMAX)STOP'<PLWMSH>:INCREASE NPLWMAX IN PARAM.DAT'
	GPLW(1,IPLW)=GX         !\
	GPLW(2,IPLW)=GY         ! > Cartesian coordinates
	GPLW(3,IPLW)=GZ         !/
	KVEC(1,IPLW)=M1         !\
	KVEC(2,IPLW)=M2         ! > Coordinates in basis "GEQU"
	KVEC(3,IPLW)=M3         !/
        M1MIN=MIN(M1MIN,M1)
        M2MIN=MIN(M2MIN,M2)
        M3MIN=MIN(M3MIN,M3)
        M1MAX=MAX(M1MAX,M1)
        M2MAX=MAX(M2MAX,M2)
        M3MAX=MAX(M3MAX,M3)
	ENDIF
 210    CONTINUE
 220    CONTINUE
 230    CONTINUE
	NPLW=IPLW
        M1MIN=M1MIN-1
        M2MIN=M2MIN-1
        M3MIN=M3MIN-1
        M1MAX=M1MAX+1
        M2MAX=M2MAX+1
        M3MAX=M3MAX+1
	DO 240 IDIM=1,NFFTMAX
	INDG(IDIM)=-1
 240    CONTINUE
C  ORDER VECTORS BY INCREASING LENGHT
	DO 260 IPLW=0,NPLW
	ABSI=SQRT(GPLW(1,IPLW)**2+GPLW(2,IPLW)**2+GPLW(3,IPLW)**2)
	DO 250 JPLW=IPLW+1,NPLW
	ABSJ=SQRT(GPLW(1,JPLW)**2+GPLW(2,JPLW)**2+GPLW(3,JPLW)**2)
	IF(ABSJ.LT.ABSI)THEN
	GXJ=GPLW(1,JPLW)
	GYJ=GPLW(2,JPLW)
	GZJ=GPLW(3,JPLW)
	M1J=KVEC(1,JPLW)
	M2J=KVEC(2,JPLW)
	M3J=KVEC(3,JPLW)
	GPLW(1,JPLW)=GPLW(1,IPLW)
	GPLW(2,JPLW)=GPLW(2,IPLW)
	GPLW(3,JPLW)=GPLW(3,IPLW)
	KVEC(1,JPLW)=KVEC(1,IPLW)
	KVEC(2,JPLW)=KVEC(2,IPLW)
	KVEC(3,JPLW)=KVEC(3,IPLW)
	GPLW(1,IPLW)=GXJ
	GPLW(2,IPLW)=GYJ
	GPLW(3,IPLW)=GZJ
	KVEC(1,IPLW)=M1J
	KVEC(2,IPLW)=M2J
	KVEC(3,IPLW)=M3J
	ABSI=ABSJ
	ENDIF
 250    CONTINUE
	M1I=KVEC(1,IPLW)
	M2I=KVEC(2,IPLW)
	M3I=KVEC(3,IPLW)
	IDIMI=1+M1I-KGMIN(1)+(KGMAX(1)-KGMIN(1)+1)*(M2I-KGMIN(2))+
     &  (KGMAX(1)-KGMIN(1)+1)*(KGMAX(2)-KGMIN(2)+1)*(M3I-KGMIN(3))
	INDG(IDIMI)=IPLW
 260    CONTINUE
C  SET UP ENERGY LIMIT IN REAL UNITS
	GMAX=SQRT(GPLW(1,NPLW)**2+GPLW(2,NPLW)**2+GPLW(3,NPLW)**2)
	EMAX=GMAX**2*(2.D0*PI/PAR)**2
	PMAX=GMAX*2.D0*PI/PAR ! cutoff value
	ECUTG=EMAX
C  SET BETTA-PARAMETERS AND CUTOFF VALUES FOR THE POTENTIAL
	DO 320 ISORT=1,NSORT
	DO 310 L=0,ILSV(ISORT)                                    
C  CUTOFF IS GMAX, FIND BETA FROM THE RECIPROCAL SPACE ACCURACY "EPSG"
	AG=LOG(EPSG)
	BG=DBLE(L)
	CALL GAROOT(AG,BG,GROOT)
	BTG=PMAX/2.D0/GROOT
C  DIRECT SPACE ACCURACY IS "EPSR", FIND BETA AGAIN
	AR=LOG(EPSR)
	BR=DBLE(L+2)
	CALL GAROOT(AR,BR,RROOT)
	BTR=RROOT/SMT(ISORT)
C  CUTOFF IS GMAX, FIND BETA FROM EPSG/EPSR
CC      RTOG=EPSR/EPSG
	RTOG=0.5D0
	CALL GAROOT1(RTOG,PMAX,SMT(ISORT),L+2,L,RROOT)
	BTN=RROOT
C  FIND OPTIMAL BETA (LET'S SEE WHICH ONE WILL WORK!)
C       BET(L,ISORT)=BTR
C       BET(L,ISORT)=(BTG+BTR)/2.D0
C       BET(L,ISORT)=MAX(BTG,BTR)
C       BET(L,ISORT)=BTG
	BET(L,ISORT)=BTN
 310    CONTINUE
 320    CONTINUE
C
	WRITE(IUN,1000)
	WRITE(IUN,1010)NPLW
	WRITE(IUN,1020)EMAX
	WRITE(IUN,1030)GMAX
	WRITE(IUN,1040)NFFTG(1),NFFTG(2),NFFTG(3)
	ID1=NFFTG(1)-(M1MAX-M1MIN)-2
	IF(ID1.LT.2)ID1=0
	ID2=NFFTG(2)-(M2MAX-M2MIN)-2
	IF(ID2.LT.2)ID2=0
	ID3=NFFTG(3)-(M3MAX-M3MIN)-2
	IF(ID3.LT.2)ID3=0
	WRITE(IUN,1050)NFFTG(1)-ID1,NFFTG(2)-ID2,NFFTG(3)-ID3
1000    FORMAT(63('*'))
1010    FORMAT(1X,'Number of plane waves to be used ',I7)
1020    FORMAT(1X,'Plane-wave energy cutoff will be ',G14.7,' Ry')
1030    FORMAT(1X,'Reciprocal lattice sphere radius ',G14.7,' 2pi/a')
1040    FORMAT(1X,'Fast fourier transform divisions ',3(I3,1X))
1050    FORMAT(1X,'FFT optimal divisions calculated ',3(I3,1X))
	END


        SUBROUTINE PLWSTR
***********************************************************
*  Distorts reciprocal space vectors according to strain. *
***********************************************************
        IMPLICIT REAL*8 (A-H,O-Z)
        INCLUDE 'PARAM.DAT'
        DIMENSION GPLW(3,0:NPLWMAX),STRAIN(3,3,2),GL(3)
     &   ,ORTH(2:3)
        COMMON /MANSTR/ ISTRAIN                               !!! from init
        COMMON /PLWMESH/NPLW,GPLW                             !!! from plwmsh
        COMMON /LATPAR/ PAR,ORTH,OMEGAC,STRAIN                !!! from init
        COMMON /UNIT/   IUN                                   !!! from init
        COMMON /WORD/   NVAL                                  !!! from nmtdata
        DATA PI/3.141592653589793D0/
C  DISTORT PLANE WAVES ACCORDING TO STRAIN
	IF(ISTRAIN.NE.1)RETURN
        DO 40 IPLW=0,NPLW
        DO 10 I=1,3
        GL(I)=GPLW(I,IPLW)
  10    CONTINUE
        DO 30 I=1,3
        GPLW(I,IPLW)=0.D0
        DO 20 J=1,3
        GPLW(I,IPLW)=GPLW(I,IPLW)+GL(J)*STRAIN(J,I,2)
  20    CONTINUE
  30    CONTINUE
  40    CONTINUE
	END




	SUBROUTINE GETPLW(JPLW,IPLW,KPLW)
*******************************************************
*  Finds reciprocal lattice vector G_k=G_j-G_i        *
*  If none, returns KPLW=-1.                          *
*******************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER INDG(NFFTMAX),KVEC(3,0:NPLWMAX),KGMIN(3),KGMAX(3)
	DIMENSION RBAS(3,3),GBAS(3,3),GPLW(3,0:NPLWMAX)
	COMMON /LATTICE/RBAS,GBAS                             !!! from init
	COMMON /PLWMESH/NPLW,GPLW,KVEC,KGMIN,KGMAX,INDG       !!! from plwmsh
	DATA PI/3.141592653589793D0/
	M1K=KVEC(1,JPLW)-KVEC(1,IPLW)
	M2K=KVEC(2,JPLW)-KVEC(2,IPLW)
	M3K=KVEC(3,JPLW)-KVEC(3,IPLW)
	KPLW=-1
	IF((M1K.GE.KGMIN(1).AND.M1K.LE.KGMAX(1)).AND.
     &     (M2K.GE.KGMIN(2).AND.M2K.LE.KGMAX(2)).AND.
     &     (M3K.GE.KGMIN(3).AND.M3K.LE.KGMAX(3)))THEN
	IDIM=1+M1K-KGMIN(1)+(KGMAX(1)-KGMIN(1)+1)*(M2K-KGMIN(2))+
     &  (KGMAX(1)-KGMIN(1)+1)*(KGMAX(2)-KGMIN(2)+1)*(M3K-KGMIN(3))
	KPLW=INDG(IDIM)
	ENDIF
	END
