	   SUBROUTINE PNTLIST
**************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER IS(NPAT),ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &   ,NDIV(3),NDIC(3),IREF(0:NVCMAX),ISG(NOPRMAX,NOPRMAX)
     &   ,NPNT(NPANMAX) 
	DIMENSION PNT(3,KMAX,NPANMAX),RBAS(3,3),GBAS(3,3),TU(3),QPOINT(3)
     &   ,TAU0(3,NPAT),TAU(3,NPAT),AK(3,3,2),RK(3,3,2),GVEC(3,0:NVCMAX)
     &   ,WGT(KMAX,NPANMAX),ORTH(2:3) 
	CHARACTER*60 KOVFILE,FTRFILE,CONFILE,OUTFILE
 	CHARACTER SYS*1,DF*1,YES*1
	LOGICAL EXIST
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM       !!! from init
	COMMON /LATTICE/RBAS,GBAS,AK,RK                     !!! from init
	COMMON /BASIS0/ TAU0                                !!! from init
	COMMON /BASIS/  TAU                                 !!! from init
        COMMON /LATPAR/ PAR,ORTH                            !!! from init
	COMMON /OUT1/   ICON,IFTR,IKOV                      !!! from init
	COMMON /OUT2/   CONFILE,FTRFILE,KOVFILE             !!! from init
	COMMON /INTTR/  NDIV,NDIC                           !!! from init
	COMMON /GROUPOUT/NGROUP                             !!! from group
	COMMON /ORBS/   NORBS                               !!! from init
	COMMON /SPIN/   NSPIN                               !!! from init
	COMMON /MESH/   NPNT,PNT,WGT                        !!! from ttrmsh
	COMMON /UNIT/   IUN,IUT,IUR,IUNOUT                  !!! from pntlist
	DATA PI/3.141592653589793D0/,EPS/1.D-05/,TU/0.D0,0.D0,0.D0/
C  CALCULATE TRANSFORMATION MATRICES
        IF(IKOV.EQ.1)SYS='C'
        IF(IKOV.EQ.2)SYS='H'
        IF(IKOV.EQ.3)SYS='A'
        CALL WIGMAT(2,SYS,KOVFILE)
        CALL GROUPS(RBAS,TAU0,IS,2,NATOM,NSPIN,NORBS,EPS,1)
	PRINT1010,NGROUP
        CALL WIGMAT(2,SYS,KOVFILE)
        CALL GROUPS(RBAS,TAU, IS,2,NATOM,NSPIN,NORBS,EPS,2)
	PRINT1020,NGROUP
C  K-MESH CONSTRUCTION
	CALL SBZMESH(NDIV,NDIC)
	PRINT1030,NPNT(1)
1000	FORMAT(A)
1010    FORMAT(1X,'Elements discovered for original  lattice  : ',I4)
1020    FORMAT(1X,'Elements found      for distorted lattice  : ',I4)
1030    FORMAT(1X,'K-points generated  in the irreducible BZ  : ',I4)
C  ASK FOR REDUCTION
	PRINT1040
        READ(5,1000)DF
        IF(DF.EQ.'Y'.OR.DF.EQ.'y'.OR.DF.EQ.' ')THEN
        IREDUCE=1
        ELSE
        IREDUCE=0
        ENDIF
C  ASK FOR STORAGE
        PRINT1045
        READ(5,1000)DF
        IUNOUT=6
        IF(DF.EQ.'Y'.OR.DF.EQ.'y')THEN
        PRINT1050
        READ(5,1000)OUTFILE
        INQUIRE(FILE=OUTFILE,EXIST=EXIST)
          IF(EXIST)THEN
          WRITE(IUN,1055)
  10      READ(IUN,1000)YES
            IF(YES.EQ.'Y'.OR.YES.EQ.'y')THEN
            OPEN(UNIT=3,FILE=OUTFILE,STATUS='OLD',FORM='FORMATTED')
            CLOSE(UNIT=3,STATUS='DELETE')
            ELSEIF(YES.EQ.'N'.OR.YES.EQ.'n')THEN
            STOP'PROGRAM TERMINATED'
            ELSE
            PRINT1065
            GOTO10
            ENDIF
          ENDIF
        OPEN(UNIT=3,FILE=OUTFILE,STATUS='NEW',FORM='FORMATTED')
        IUNOUT=3
        ENDIF
1040    FORMAT(1X,$,'Reduce points to their minimal length [y/n]: ')
1045    FORMAT(1X,$,'Store irreducible points to OUTFILE   [y/n]: ')
1050    FORMAT(1X,$,'OUTFILE? ')
1055    FORMAT(1X,$,'Output file exist, overwrite it [y/n]: ')
1065    FORMAT(1X,$,'Please enter Y or N: ')
C  STORE HEAD
        WRITE(IUNOUT,1060)NPNT(1),(NDIV(I),I=1,3),(ORTH(I),I=2,3)
        WRITE(IUNOUT,1070)
        WRITE(IUNOUT,1080)1,GBAS(1,1),GBAS(2,1)*ORTH(2),
     &  GBAS(3,1)*ORTH(3)
        WRITE(IUNOUT,1080)2,GBAS(1,2),GBAS(2,2)*ORTH(2),
     &  GBAS(3,2)*ORTH(3)
        WRITE(IUNOUT,1080)3,GBAS(1,3),GBAS(2,3)*ORTH(2),
     &  GBAS(3,3)*ORTH(3)
        WRITE(IUNOUT,1090)
        N1=NDIV(1)
        N2=NDIV(2)
        N3=NDIV(3)
C  FIND SPHERE RADIUS CIRCUMSCRIBING BZ
        RMAX=0.D0
        DO 50 IZ=-1,1
        DO 50 JZ=-1,1
        DO 50 KZ=-1,1
        RSUM=0.D0
        DO 40 I=1,3
        RSUM=RSUM+(IZ*AK(I,1,1)*N1+JZ*AK(I,2,1)*N2+
     &  KZ*AK(I,3,1)*N3)**2
  40    CONTINUE
        RMAX=MAX(RMAX,RSUM)
  50    CONTINUE
        RMAX=SQRT(RMAX)+0.1D0
C  GENERATE ALL RECIPROCAL LATTICE VECTORS INSIDE SPHERE "RMAX"
        CALL SITEGEN(RMAX,GBAS(1,1),GBAS(1,2),GBAS(1,3),TU,1,NVEC,
     &  GVEC,IREF)
        NVEC=NVEC-1
        DO 60 IPNT=1,NPNT(1)
        QPOINT(1)=PNT(1,IPNT,1)
        QPOINT(2)=PNT(2,IPNT,1)
        QPOINT(3)=PNT(3,IPNT,1)
        IF(IREDUCE.EQ.1)
     &  CALL REDUC2(PNT(1,IPNT,1),PNT(2,IPNT,1),PNT(3,IPNT,1),
     &  NVEC,GVEC,QPOINT(1),QPOINT(2),QPOINT(3),GRX,GRY,GRZ)
C  GET COORDINATES IN UNITS OF AK
C       J1=ANINT(QPOINT(1)*RK(1,1,1)+QPOINT(2)*RK(2,1,1)+
C    &  QPOINT(3)*RK(3,1,1))
C       J2=ANINT(QPOINT(1)*RK(1,2,1)+QPOINT(2)*RK(2,2,1)+
C    &  QPOINT(3)*RK(3,2,1))
C       J3=ANINT(QPOINT(1)*RK(1,3,1)+QPOINT(2)*RK(2,3,1)+
C    &  QPOINT(3)*RK(3,3,1))
C  FIND SYMMETRY
        CALL SYMQVEC(QPOINT(1),QPOINT(2),QPOINT(3),
     &  NGEQ,NSGQ,ISG,RK(1,1,1))
        WRITE(IUNOUT,1100)IPNT,QPOINT(1),QPOINT(2)*ORTH(2),
     &  QPOINT(3)*ORTH(3),WGT(IPNT,1)/2.D0,NGEQ,NSGQ
c  estimate lenght
	print*,sqrt(qpoint(1)**2+qpoint(2)**2+qpoint(3)**2)
  60    CONTINUE
1060    FORMAT(1X,I4,',',1X,3(I2,1X),1X,2(G12.5,1X),' - # of q"s,',
     &  ' n1 n2 n3, b/a, c/a')
1070    FORMAT(1X,7('*'),' Reciprocal translations (units 2pi/a):',
     &  28('*'))
1080    FORMAT(1X,'G',I1,' = (',G14.7,',',G14.7,',',G14.7,')')
1090    FORMAT(1X,'Ipnt:',3X,'Irreducible points in BZ (units 2pi/a):',
     &  30X,'Weight',5X,' Ng  Ns')
1100    FORMAT(1X,I4,1X,G21.14,1X,G21.14,1X,G21.14,
     &  2X,G13.6,4X,I2,2X,I2)
1110    FORMAT(1X,7('*'),' Direct lattice translations (units a):',
     &  28('*'))
1120    FORMAT(1X,'R',I1,' = (',G14.7,',',G14.7,',',G14.7,')')
1130    FORMAT(1X,'Ipnt:',3X,'Irreducible direct  vectors (units a):',
     &  30X,'Coord:',5X,' Ng  Ns')
1140    FORMAT(1X,I4,1X,G21.14,1X,G21.14,1X,G21.14,2X,
     &  '(',I3,1X,I3,1X,I3,')',4X,I2,2X,I2)
        END


        SUBROUTINE SYMQVEC(QX,QY,QZ,NGEQ,NSGQ,ISG,RK)
************************************************************
*  Calculates point group for given vector q=(qx,qy,qz)    *
************************************************************
        IMPLICIT REAL*8 (A-H,O-Z)
        INCLUDE 'PARAM.DAT'
        INTEGER IP(NPAT,NOPRMAX),IKOV(NOPRMAX),ISG(NOPRMAX,NOPRMAX)
     &   ,KQG(3,NOPRMAX)
        DIMENSION RK(3,3)
        COMPLEX*16 U(NWIGMAX,48)
        COMMON /INVERS/ INV,IKOV                        !!! from group
        COMMON /GROUPOUT/NGROUP,U                       !!! from group
        COMMON /UNIT/   IUN                             !!! from read
C  ROTATE Q-VECTOR BY RECIPROCAL SYMMETRY OPERATIONS
        DO 10 IR=1,NGROUP                               !!! over group
        IG=IKOV(IR)
        CALL ROTATE(QX,QY,QZ,Q1,Q2,Q3,U(2,IG),1)
        X1=Q1*RK(1,1)+Q2*RK(2,1)+Q3*RK(3,1)
        X2=Q1*RK(1,2)+Q2*RK(2,2)+Q3*RK(3,2)
        X3=Q1*RK(1,3)+Q2*RK(2,3)+Q3*RK(3,3)
        J1=ANINT(X1)
        J2=ANINT(X2)
        J3=ANINT(X3)
C  CHECK WHETHER THE Q-VECTOR IS ON THE GRID
        IF(ABS(X1-J1).GE.1.D-03.OR.ABS(X2-J2).GE.1.D-03.OR.ABS(X3-J3).
     &  GE.1.D-03)STOP'<SYMQVEC>: Q-COORDINATES ARE NOT INTEGER'
        KQG(1,IR)=J1
        KQG(2,IR)=J2
        KQG(3,IR)=J3
  10    CONTINUE                                       !!! over group
C  DEFINE # OF ELEMENTS IN Q-STAR
        NSGQ=0
        NGEQ=0
        DO 60 IR=1,NGROUP
        NEC=1
        DO 30 ISGQ=1,NSGQ
        DO 20 IGEQ=1,NGEQ
        IF(ISG(IGEQ,ISGQ).EQ.IR)NEC=0
  20    CONTINUE
  30    CONTINUE
        IF(NEC.EQ.1)THEN
        NSGQ=NSGQ+1
        NGEQ=0
        DO 50 IR1=IR,NGROUP                            !!! over group
        NEQ=0
        DO 40 I=1,3
        IF(KQG(I,IR).EQ.KQG(I,IR1))NEQ=NEQ+1
  40    CONTINUE
        IF(NEQ.EQ.3)THEN
        NGEQ=NGEQ+1
        ISG(NGEQ,NSGQ)=IR1
        ENDIF
  50    CONTINUE                                       !!! over group
        ENDIF
  60    CONTINUE
        END




        SUBROUTINE REDUC2(DX,DY,DZ,NVEC,VEC,DRX,DRY,DRZ,RX,RY,RZ)
*****************************************************************
*  Represents vector D as Dr-R, where Dr has a minimal lenght   *
*  and R is one of the lattice vectors VEC.                     *
*****************************************************************
        IMPLICIT REAL*8 (A-H,O-Z)
        DIMENSION VEC(3,NVEC)
        DRX=DX
        DRY=DY
        DRZ=DZ
        ABSDR=SQRT(DRX*DRX+DRY*DRY+DRZ*DRZ)
        RX=0.D0
        RY=0.D0
        RZ=0.D0
        DO 10 IVEC=1,NVEC
        TRX=DX+VEC(1,IVEC)
        TRY=DY+VEC(2,IVEC)
        TRZ=DZ+VEC(3,IVEC)
        ABSTR=SQRT(TRX*TRX+TRY*TRY+TRZ*TRZ)
        IF(ABSTR.GE.ABSDR)GOTO10
        DRX=TRX
        DRY=TRY
        DRZ=TRZ
        ABSDR=ABSTR
        RX=VEC(1,IVEC)
        RY=VEC(2,IVEC)
        RZ=VEC(3,IVEC)
  10    CONTINUE
        END





        SUBROUTINE CROSS(A,B,C)
**********************************************************
*    Cross product (AX,AY,AZ)=(BX,BY,BZ)*(CX,CY,CZ)      *
**********************************************************
        IMPLICIT REAL*8 (A-H,O-Z)
        DIMENSION A(3),B(3),C(3)
        A(1)=B(2)*C(3)-B(3)*C(2)
        A(2)=B(3)*C(1)-B(1)*C(3)
        A(3)=B(1)*C(2)-B(2)*C(1)
        RETURN
        END
