        SUBROUTINE READSTR
************************************************************
*  <READSTR> reads crystalline structure and IBZ data      *
************************************************************
        IMPLICIT REAL*8 (A-H,O-Z)
        INCLUDE 'PARAM.DAT'
        INTEGER IS(NPAT),ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &    ,NDIV(3),NDIC(3)
        DIMENSION RBASR(3,3),TAUR(3,NPAT),BASR(3),BBASR(3,3),ORTH(2:3)
     &    ,GBAS(3,3),RBAS(3,3),BBAS(3,3),TAU(3,NPAT),STRAIN(3,3,2)
     &    ,SH(3,NPANMAX),AK(3,3,2),RK(3,3,2),HSPNT(3,2,KMAX)
     &    ,HSPNTR(3,2,KMAX),RSTN(3,3),TAU0(3,NPAT),TAU0R(3,NPAT)
        CHARACTER*60 INIFILE,SC0FILE,STRFILE,KOVFILE,CONFILE,FTRFILE
        CHARACTER PNTNOT(2,KMAX)*1,TEXT*64,TEXTS*64,STRING(80)*1
     &    ,SYS*1,TXT*72
C Controls:
        COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM   !!! from readini
        COMMON /MANSTR/ ISTRAIN,IBAS,IBZ,ICALC          !!! from readstr
C Lattice:
        COMMON /LATTICE/RBAS,GBAS,AK,RK                 !!! from readstr
        COMMON /BASIS/  TAU                             !!! from readstr
        COMMON /BASIS0/ TAU0                            !!! from readstr
        COMMON /LATPAR/ PAR,ORTH,OMEGAC,STRAIN          !!! from readini
C K-mesh:
        COMMON /INP0/   INIFILE,SC0FILE,STRFILE         !!! from readini
        COMMON /INTTR/  NDIV,NDIC,SH,NDIR,HSPNT         !!! from readstr
        COMMON /HSPNTS/ PNTNOT                          !!! from readstr
        COMMON /STRINP/ NVECMX,ALPHA                    !!! from readstr
        COMMON /SRFINP/ NDIV1,NDIV2                     !!! from readstr
C Outputs:
        COMMON /OUT1/   ICCON,ICFTR,ICKOV               !!! from readstr
        COMMON /OUT2/   CONFILE,FTRFILE,KOVFILE         !!! from readstr
        COMMON /TEXT/   TEXT,TEXTS                      !!! from readini
        COMMON /UNIT/   IUN                             !!! from readini
        DATA PI/3.141592653589793D0/
C--------------------------------------------
C****** READ STRFILE ************************ 
C--------------------------------------------
        OPEN(UNIT=1,FILE=STRFILE,STATUS='OLD')
        READ(1,1000)TEXTS
C  **** MAIN PARAMETERS *********************
C  NATOM - number of atoms in unit-cell
C  ORTH  - ortorhombicity, i.e. b/a, c/a
C  IBAS  - if 1 then Cartesian, else in RBAS
C  IBZ   - if 1 then from RBAS, else input
C  ICALC - if 1 using the calculator
C  ISTRAIN - if 1 plane waves follow the distortions
C  NDIV1 - generation of polyhedra parameter
C  NDIV2 - polyhedron surface mesh parameter
C  NVECMX - number of structure vectors
C  ALPHA - Evald's splitting parameter
        READ(1,1001)TXT
        READ(1,*) NATOM0,ORTH
        READ(1,*) IBAS,IBZ,ICALC,ISTRAIN
        READ(1,*) NDIV1,NDIV2
        READ(1,*) NVECMX,ALPHA
        IF(NATOM0.NE.NATOM)STOP'<READSTR>: # OF ATOMS MISMATCHES
     &  IN STRFILE, CHECK IT'
C  **** PRIMITIVE TRANSLATIONS **************
C  RBAS(1:3,IVEC) - x,y,z components of translations
        READ(1,1000)TXT
        DO IVEC=1,3
        IF(ICALC.NE.1)THEN
        READ(1,*)(RBASR(I,IVEC),I=1,3)
        ELSEIF(ICALC.EQ.1)THEN
        READ(1,1020)STRING
        CALL COMPVEC(STRING,RBASR(1,IVEC),3)
        ENDIF
	ENDDO
C  **** BASIS ATOMS IN ORIGINAL CELL ****************
C  TAU0  - positions of atoms in original cell
        READ(1,1000)TXT
        DO IATOM=1,NATOM
        IF(IBAS.EQ.1)THEN     !!! basis in Cartesian coordinates
        IF(ICALC.NE.1)THEN
        READ(1,*)(TAU0R(I,IATOM),I=1,3)
        ELSEIF(ICALC.EQ.1)THEN!!! using calculator
        READ(1,1020)STRING
        CALL COMPVEC(STRING,TAU0R(1,IATOM),3)
        ENDIF
        ELSEIF(IBAS.NE.1)THEN !!! basis in units of RBAS
        IF(ICALC.NE.1)THEN
        READ(1,*)(BASR(I),I=1,3)
        ELSEIF(ICALC.EQ.1)THEN!!! using calculator
        READ(1,1020)STRING
        CALL COMPVEC(STRING,BASR(1),3)
        ENDIF
        TAU0R(1,IATOM)=BASR(1)*RBASR(1,1)
     &                +BASR(2)*RBASR(1,2)
     &                +BASR(3)*RBASR(1,3)
        TAU0R(2,IATOM)=BASR(1)*RBASR(2,1)
     &                +BASR(2)*RBASR(2,2)
     &                +BASR(3)*RBASR(2,3)
        TAU0R(3,IATOM)=BASR(1)*RBASR(3,1)
     &                +BASR(2)*RBASR(3,2)
     &                +BASR(3)*RBASR(3,3)
        ENDIF
	ENDDO
C  **** BASIS ATOMS IN DISTORTED CELL ****************
C  TAU  - actual positions of atoms
        READ(1,1000)TXT
        DO IATOM=1,NATOM
        IF(IBAS.EQ.1)THEN     !!! basis in Cartesian coordinates
        IF(ICALC.NE.1)THEN
        READ(1,*)(TAUR(I,IATOM),I=1,3)
        ELSEIF(ICALC.EQ.1)THEN!!! using calculator
        READ(1,1020)STRING
        CALL COMPVEC(STRING,TAUR(1,IATOM),3)
        ENDIF
        ELSEIF(IBAS.NE.1)THEN !!! basis in units of RBAS
        IF(ICALC.NE.1)THEN
        READ(1,*)(BASR(I),I=1,3)
        ELSEIF(ICALC.EQ.1)THEN!!! using calculator
        READ(1,1020)STRING
        CALL COMPVEC(STRING,BASR(1),3)
        ENDIF
        TAUR(1,IATOM)=BASR(1)*RBASR(1,1)
     &               +BASR(2)*RBASR(1,2)
     &               +BASR(3)*RBASR(1,3)
        TAUR(2,IATOM)=BASR(1)*RBASR(2,1)
     &               +BASR(2)*RBASR(2,2)
     &               +BASR(3)*RBASR(2,3)
        TAUR(3,IATOM)=BASR(1)*RBASR(3,1)
     &               +BASR(2)*RBASR(3,2)
     &               +BASR(3)*RBASR(3,3)
        ENDIF
	ENDDO
C  **** STRAIN MATRIX ***********************                      _
C  STRAIN(1..3,1..3) - matrix applied to translations and basis R'=S*R
C  Its diagonal components in case no strain are just 1,1,1
        READ(1,1000)TXT
        DO I=1,3
        IF(ICALC.NE.1)THEN
        READ(1,*)(STRAIN(I,J,1),J=1,3)
        ELSEIF(ICALC.EQ.1)THEN
        READ(1,1020)STRING
        CALL COMPVEC(STRING,BASR(1),3)
        STRAIN(I,1,1)=BASR(1)
        STRAIN(I,2,1)=BASR(2)
        STRAIN(I,3,1)=BASR(3)
        ENDIF
	ENDDO
C  SET RECIPROCAL STRAIN MATRIX: S*S^(-1)=1
        CALL CROSS(RSTN(1,1),STRAIN(1,2,1),STRAIN(1,3,1))
        CALL CROSS(RSTN(1,2),STRAIN(1,3,1),STRAIN(1,1,1))
        CALL CROSS(RSTN(1,3),STRAIN(1,1,1),STRAIN(1,2,1))
        W=STRAIN(1,1,1)*RSTN(1,1)
     &   +STRAIN(2,1,1)*RSTN(2,1)
     &   +STRAIN(3,1,1)*RSTN(3,1)
        IF(ABS(W).LE.1.D-10)STOP'<READSTR>:: WRONG STRAIN, DET=0'
        DO I=1,3
        STRAIN(1,I,2)=RSTN(I,1)/W
        STRAIN(2,I,2)=RSTN(I,2)/W
        STRAIN(3,I,2)=RSTN(I,3)/W
	ENDDO
C  **** POINT GROUP DESCRIPTION *************
C  SYS - C(cubic) or H(hexogonal) system of rotations
C      - A(arbitrary) system can be also specified.
C        Group operations must be listed in KOVFILE,
C        see WIGMAT subroutine for more details.
        READ(1,1000)TXT
        READ(1,*)SYS
        IF(SYS.EQ.'C')ICKOV=1
        IF(SYS.EQ.'H')ICKOV=2
        IF(SYS.EQ.'A')ICKOV=3
        KOVFILE(1:6)='      '
        IF(ICKOV.EQ.3)THEN
        BACKSPACE(1)
        READ(1,*)SYS,KOVFILE
        ENDIF
C  ****  BRILLOUIN ZONE **********
C  BBAS - three primitive translations (possibly reciprocal lattice vectors)
        READ(1,1000)TXT
        DO IVEC=1,3
        IF(ICALC.NE.1)THEN
        READ(1,*)(BBASR(I,IVEC),I=1,3)
        ELSEIF(ICALC.EQ.1)THEN
        READ(1,1020)STRING
        CALL COMPVEC(STRING,BBASR(1,IVEC),3)
        ENDIF
	ENDDO
C  **** HIGH-SYMMETRY DIRECTION SETTINGS ****
C  NDIR - number of directions to be calculated
C  HSPNT(1:3,1:2,IDIR) - starting and end points
        READ(1,1000)TXT
        READ(1,*)NDIR                             !!! # of h.s. directions
        IF(NDIR.GT.KMAX)STOP'<READSTR>: # OF DIRECTIONS IS TOO LARGE,
     &  ALLOWED # IS EQUAL TO KMAX'
        DO IDIR=1,NDIR
        READ(1,1010)(PNTNOT(IVEC,IDIR),IVEC=1,2)
        IF(ICALC.NE.1)THEN
        READ(1,*)((HSPNTR(I,IVEC,IDIR),I=1,3),IVEC=1,2) ! high-symmetry dirs
        ELSEIF(ICALC.EQ.1)THEN
        READ(1,1020)STRING
        CALL COMPVEC(STRING,HSPNTR(1,1,IDIR),6)
        ENDIF
	ENDDO
        CLOSE(1)
C  ACCOUNT FOR ORTHOROMBICITY PARAMETERS
        DO I=2,3
        DO IVEC=1,3
        RBASR(I,IVEC)=RBASR(I,IVEC)*ORTH(I)
        BBASR(I,IVEC)=BBASR(I,IVEC)/ORTH(I)
	ENDDO
        DO IATOM=1,NATOM
        TAU0R(I,IATOM)=TAU0R(I,IATOM)*ORTH(I)
        TAU R(I,IATOM)=TAU R(I,IATOM)*ORTH(I)
	ENDDO
	ENDDO
        DO I=2,3
        DO IVEC=1,2
        DO IDIR=1,NDIR
        HSPNTR(I,IVEC,IDIR)=HSPNTR(I,IVEC,IDIR)/ORTH(I)
	ENDDO
	ENDDO
	ENDDO
C  APPLY STRAIN MATRIX FOR TRANSLATIONS:  R'=S*R
        DO IVEC=1,3
        DO I=1,3
        RBAS(I,IVEC)=0.D0
        DO J=1,3
        RBAS(I,IVEC)=RBAS(I,IVEC)+STRAIN(I,J,1)*RBASR(J,IVEC)
	ENDDO
	ENDDO
	ENDDO
C  APPLY STRAIN FOR BASIS VECTORS:  T'=S*T
        DO IATOM=1,NATOM
        DO I=1,3
        TAU (I,IATOM)=0.D0
        TAU0(I,IATOM)=0.D0
        DO J=1,3
        TAU (I,IATOM)=TAU (I,IATOM)+STRAIN(I,J,1)*TAU R(J,IATOM)
        TAU0(I,IATOM)=TAU0(I,IATOM)+STRAIN(I,J,1)*TAU0R(J,IATOM)
	ENDDO
	ENDDO
	ENDDO
C  APPLY INVERSE STRAIN FOR BRILLOUIN ZONE: BZ'=BZ*S^(-1)
        DO IVEC=1,3
        DO I=1,3
        BBAS(I,IVEC)=0.D0
        DO J=1,3
        BBAS(I,IVEC)=BBAS(I,IVEC)+BBASR(J,IVEC)*STRAIN(J,I,2)
	ENDDO
	ENDDO
	ENDDO
C  APPLY INVERSE STRAIN TO HIGH-SYMMETRY DIRECTIONS: K'=K*S^(-1)
        DO IDIR=1,NDIR
        DO IVEC=1,2
        DO I=1,3
        HSPNT(I,IVEC,IDIR)=0.D0
        DO J=1,3
        HSPNT(I,IVEC,IDIR)=HSPNT(I,IVEC,IDIR)+
     &  HSPNTR(J,IVEC,IDIR)*STRAIN(J,I,2)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
C  SET RECIPROCAL LATTICE VECTORS WITHOUT 2*PI
        CALL CROSS(GBAS(1,1),RBAS(1,2),RBAS(1,3))
        CALL CROSS(GBAS(1,2),RBAS(1,3),RBAS(1,1))
        CALL CROSS(GBAS(1,3),RBAS(1,1),RBAS(1,2))
        W=RBAS(1,1)*GBAS(1,1)
     &   +RBAS(2,1)*GBAS(2,1)
     &   +RBAS(3,1)*GBAS(3,1)
        DO I=1,3
        GBAS(I,1)=GBAS(I,1)/W
        GBAS(I,2)=GBAS(I,2)/W
        GBAS(I,3)=GBAS(I,3)/W
	ENDDO
        OMEGAC=ABS(W)*PAR**3
C  SET BRILLOUIN ZONE TO GBAS IF REQUIRED
        IF(IBZ.EQ.1)THEN
        DO I=1,3
        BBAS(I,1)=GBAS(I,1)
        BBAS(I,2)=GBAS(I,2)
        BBAS(I,3)=GBAS(I,3)
	ENDDO
        ENDIF
C  SET PRIMITIVE TRANSLATIONS FOR BZ AND PRIMITIVE CELL
        DO I=1,3
        AK(I,1,1)=BBAS(I,1)/NDIV(1)
        AK(I,2,1)=BBAS(I,2)/NDIV(2)
        AK(I,3,1)=BBAS(I,3)/NDIV(3)
        AK(I,1,2)=BBAS(I,1)/NDIC(1)
        AK(I,2,2)=BBAS(I,2)/NDIC(2)
        AK(I,3,2)=BBAS(I,3)/NDIC(3)
	ENDDO
C  SET TRANSLATIONS WHICH ARE RECIPROCAL TO AK AND AD
        DO IP=1,2
        CALL CROSS(RK(1,1,IP),AK(1,2,IP),AK(1,3,IP))
        CALL CROSS(RK(1,2,IP),AK(1,3,IP),AK(1,1,IP))
        CALL CROSS(RK(1,3,IP),AK(1,1,IP),AK(1,2,IP))
        WK=AK(1,1,IP)*RK(1,1,IP)+AK(2,1,IP)*RK(2,1,IP)+
     &  AK(3,1,IP)*RK(3,1,IP)
        DO I=1,3
        RK(I,1,IP)=RK(I,1,IP)/WK
        RK(I,2,IP)=RK(I,2,IP)/WK
        RK(I,3,IP)=RK(I,3,IP)/WK
	ENDDO
	ENDDO
1000    FORMAT(A)
1001    FORMAT(/A)
1010    FORMAT(2(1X,A1))
1020    FORMAT(80A1)
        END
