	SUBROUTINE SETPAR
***********************************************************
*  Sets optimal eta-parameters for gaussian waves.        *
***********************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER IS(NPAT),ILST(NSORTMAX),ILSB(NSORTMAX)
     &   ,LBAS(0:LMAXB,NSORTMAX,NKAPMAX,NPANMAX)
     &   ,ILSV(NSORTMAX),NKAP(NPANMAX)
	DIMENSION RBAS(3,3),GBAS(3,3),TAU(3,NPAT),ORTH(2:3)
     &   ,GPLW(3,0:NPLWMAX),SMT(NSORTMAX)
     &   ,ETA(0:LMAXB,NSORTMAX,NKAPMAX,NPANMAX)
     &   ,CUT(0:LMAXB,NSORTMAX,NKAPMAX,NPANMAX)
	COMPLEX*16 EKAP(NKAPMAX,NPANMAX),EK(NKAPMAX,NPANMAX)
        LOGICAL LTPAN(0:LMAXT+1,NPAT,NKAPMAX,NPANMAX)
     &   ,LSPAN(0:LMAXT+1,NSORTMAX,NKAPMAX,NPANMAX)
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM         !!! from init
	COMMON /LATTICE/RBAS,GBAS                             !!! from init
	COMMON /BASIS/  TAU                                   !!! from init
	COMMON /POTCOM/ SWZ,SMT                               !!! from init
        COMMON /PANPAR/ LTPAN,LSPAN                           !!! from init
	COMMON /ACCURG/ EPSR,EPSG,ECUTG                       !!! from init
	COMMON /PLWMESH/NPLW,GPLW                             !!! from plwmsh
	COMMON /ETAPAR/ ETA,CUT,LBAS,NBAS                     !!! from plwmsh
	COMMON /KAPPAR/ NPAN,NKAP,EK,EKAP                     !!! from init
	COMMON /LATPAR/ PAR,ORTH,OMEGAC                       !!! from init
	COMMON /UNIT/   IUN                                   !!! from init
	COMMON /WORD/   NVAL                                  !!! from nmtdata
	DATA PI/3.141592653589793D0/
C  CALCULATE ETA-PARAMETERS AND CUTOFF VALUES IN RECIPROCAL SPACE
	DO 40 IPAN=1,NPAN
	DO 30 ISORT=1,NSORT
	DO 20 IKAP=1,NKAP(IPAN)
	DO 10 L=0,ILSB(ISORT)
C  LOCALIZATION ACCURACY IN DIRECT SPACE IS GIVEN BY ETA(L)
C       IF(L.LE.2)LCUT=MIN(ILSB(ISORT),2)
C       IF(L.GT.2)LCUT=L
	LCUT=L
	IF(IPAN.GT.1.AND.L.LE.2)LCUT=MIN(ILSB(ISORT),2)
	AR=LOG(EPSR)
	BR=DBLE(LCUT+2)
	CALL GAROOT(AR,BR,RROOT)
	ETA(L,ISORT,IKAP,IPAN)=RROOT/SMT(ISORT)
C  CUTOFF VECTOR IN RECIPROCAL SPACE IS GIVEN BY CUT(L)
	AG=LOG(EPSG)
	BG=DBLE(LCUT)
	CALL GAROOT(AG,BG,GROOT)
	CUT(L,ISORT,IKAP,IPAN)=GROOT*2.D0*ETA(L,ISORT,IKAP,IPAN)
	IF(CUT(L,ISORT,IKAP,IPAN)**2.LE.DREAL(EKAP(IKAP,IPAN)))
     &  STOP'<PLWMSH>: CUTOFF IN RECIPROCAL SPACE IS TOO SMALL'
  10    CONTINUE
  20    CONTINUE
  30    CONTINUE
  40    CONTINUE
C  SET UP NUMBER OF PLANE WAVES FOR EVERY BASIS FUNCTION
	CUTG=0.D0
	NBAS=0
	DO 130 IPAN=1,NPAN
	DO 130 IKAP=1,NKAP(IPAN)
	DO 130 ISORT=1,NSORT
	DO 130 L=0,ILSB(ISORT)
	IF(LSPAN(L,ISORT,IKAP,IPAN))THEN
	CUTI=CUT(L,ISORT,IKAP,IPAN)*PAR/2.D0/PI
C  SET CUTOFF=GMAX
	DO 110 IPLW=0,NPLW
	ABSI=SQRT(GPLW(1,IPLW)**2+GPLW(2,IPLW)**2+GPLW(3,IPLW)**2)
	IF(ABSI.LE.CUTI.AND.IPLW+1.GT.NPLW)
     &  STOP'<PLWMSH>:: ERROR IN GENERATING "LBAS"'
	IF(ABSI.LE.CUTI)GMAX=
     &  SQRT(GPLW(1,IPLW+1)**2+GPLW(2,IPLW+1)**2+GPLW(3,IPLW+1)**2)
 110    CONTINUE
	GMAX=GMAX+1.D-10
C  SET LBAS
	DO 120 IPLW=0,NPLW
	ABSI=SQRT(GPLW(1,IPLW)**2+GPLW(2,IPLW)**2+GPLW(3,IPLW)**2)
	IF(ABSI.LE.GMAX)LBAS(L,ISORT,IKAP,IPAN)=IPLW
	IF(ABSI.LE.GMAX)CUT (L,ISORT,IKAP,IPAN)=ABSI*2.D0*PI/PAR
 120    CONTINUE
	CUTG=MAX(CUTG,GMAX)
	NBAS=MAX(NBAS,LBAS(L,ISORT,IKAP,IPAN))
        ELSE
        LBAS(L,ISORT,IKAP,IPAN)=1
        ENDIF
 130    CONTINUE
	IF(NBAS.GT.NBASMAX)STOP'<PLWMSH>::INCREASE NBASMAX IN PARAM.DAT'
C  SET UP ENERGY LIMIT IN REAL UNITS
	GMAX=SQRT(GPLW(1,NPLW)**2+GPLW(2,NPLW)**2+GPLW(3,NPLW)**2)
	EMAX=GMAX**2*(2.D0*PI/PAR)**2
	DO 210 IPAN=1,NPAN
	DO 210 IKAP=1,NKAP(IPAN)
	DO 210 ISORT=1,NSORT
	DO 210 L=0,ILSB(ISORT)
        IF(.NOT.LSPAN(L,ISORT,IKAP,IPAN))GOTO210
	LPLW=LBAS(L,ISORT,IKAP,IPAN)
	GCUT=SQRT(GPLW(1,LPLW)**2+GPLW(2,LPLW)**2+GPLW(3,LPLW)**2)
	ECUT=GCUT**2*(2.D0*PI/PAR)**2
	IF(ECUT.GE.EMAX)STOP
     &  '<SETPAR> : EMAX<ECUT, EMAX MUST BE INCREASED'
 210    CONTINUE
	END


        SUBROUTINE TEIPAR
******************************************************************
* Selects maximal # of plane waves which can affect k-dependence *
* of the interstitial-potential matrix elements. The rest will be*
* taken into account by Teilor series with respect to k-vector.  *
******************************************************************
        IMPLICIT REAL*8 (A-H,O-Z)
        INCLUDE 'PARAM.DAT'
        DIMENSION GPLW(3,0:NPLWMAX),STRAIN(3,3,2)
     &   ,ORTH(2:3),RBAS(3,3),GBAS(3,3),GEQU(3,3)                     
        COMMON /LATTICE/RBAS,GBAS                             !!! from init
	COMMON /TEILORG/KEYT,BZM,GOPT,MBAS                    !!! from init
        COMMON /PLWMESH/NPLW,GPLW                             !!! from plwmsh
        COMMON /LATPAR/ PAR,ORTH,OMEGAC,STRAIN                !!! from init
        COMMON /MANSTR/ ISTRAIN                               !!! from init
        COMMON /UNIT/   IUN                                   !!! from init
        COMMON /WORD/   NVAL                                  !!! from nmtdata
        DATA PI/3.141592653589793D0/
C  SET RECIPROCAL LATTICE FOR THE CELL IN THE EQUILLIBRIUM
        IF(ISTRAIN.EQ.1)THEN
        DO 30 IVEC=1,3
        DO 20 I=1,3
        GEQU(I,IVEC)=0.D0
        DO 10 J=1,3
        GEQU(I,IVEC)=GEQU(I,IVEC)+GBAS(J,IVEC)*STRAIN(J,I,1)
  10    CONTINUE
  20    CONTINUE
  30    CONTINUE
        ELSEIF(ISTRAIN.NE.1)THEN
        DO 40 IVEC=1,3
        GEQU(1,IVEC)=GBAS(1,IVEC)
        GEQU(2,IVEC)=GBAS(2,IVEC)
        GEQU(3,IVEC)=GBAS(3,IVEC)
  40    CONTINUE
        ENDIF
C  FIND POSSIBLE K-VECTOR OF LARGEST LENGHT
	N3=2
	N2=2
	N1=2
	BZMAX=0.D0
	DO 130 I3=0,N3
	DO 120 I2=0,N2
	DO 110 I1=0,N1
	XK=GEQU(1,1)/DBLE(N1)*DBLE(I1)
     &	  +GEQU(1,2)/DBLE(N2)*DBLE(I2)
     &	  +GEQU(1,3)/DBLE(N3)*DBLE(I3)
	YK=GEQU(2,1)/DBLE(N1)*DBLE(I1)
     &	  +GEQU(2,2)/DBLE(N2)*DBLE(I2)
     &	  +GEQU(2,3)/DBLE(N3)*DBLE(I3)
	ZK=GEQU(3,1)/DBLE(N1)*DBLE(I1)
     &	  +GEQU(3,2)/DBLE(N2)*DBLE(I2)
     &	  +GEQU(3,3)/DBLE(N3)*DBLE(I3)
	CALL REDUC2(XK,YK,ZK,NPLW,GPLW(1,0),XKR,YKR,ZKR,
     &  GRX,GRY,GRZ)
	BZMAX=MAX(BZMAX,SQRT(XKR**2+YKR**2+ZKR**2))
 110	CONTINUE
 120	CONTINUE
 130	CONTINUE
	BZMAX=BZMAX+1.D-10
	GOPT=BZM*BZMAX
C  FIND # OF VECTORS WITHIN A SPHERE "GSMAL"
	DO 210 IPLW=0,NPLW
	ABSI=SQRT(GPLW(1,IPLW)**2+GPLW(2,IPLW)**2+GPLW(3,IPLW)**2)
	IF(ABSI.GT.GOPT)GOTO220
 210	CONTINUE
 220	MBAS=IPLW-1
	IF(KEYT.EQ.0)MBAS=NPLW+1
	IF(MBASMAX.GT.NBASMAX)STOP'MBASMAX MUST BE .LE. NBASMAX'
	IF(MBAS.GT.MBASMAX.AND.KEYT.GT.0)STOP
     &  'INCREASE MBASMAX IN PARAM.DAT OR DECREASE BZM IN <INIFILE>'
	WRITE(IUN,1000)
        WRITE(IUN,1010)MBAS
        WRITE(IUN,1020)BZMAX
        WRITE(IUN,1030)GOPT
        WRITE(IUN,1040)GOPT**2*(2.D0*PI/PAR)**2
1000    FORMAT(63('*'))
1010    FORMAT(1X,'# of (k+G)-terms in Fourier sums ',I7)
1020    FORMAT(1X,'Brillouin zone radius calculated ',G14.7,' 2pi/a')
1030    FORMAT(1X,'Teilor"s sphere radius estimated ',G14.7,' 2pi/a')
1040    FORMAT(1X,'Teilor"s cutoff energy estimated ',G14.7,' Ry   ')
	END


	SUBROUTINE GAROOT(A,B,ROOT)
*****************************************************
*  Finds largest root for x^2=b*ln(x)-a when x>0.   *
*****************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	DATA ACCU/1.D-10/
	XMAX=20.D0
  10    VAL=A-B*LOG(XMAX)+XMAX**2
	IF(VAL.LT.0.D0)XMAX=XMAX*2.D0
	IF(VAL.LT.0.D0)GOTO10
	DO 20 X=XMAX,0.D0,-0.01D0
	IF(X.EQ.0.D0)STOP' NO ROOT FOUND IN <GAROOT>'
	VALL=A-B*LOG(X)+X**2
	IF(VALL.LT.0.D0)XLEFT=X
	IF(VALL.LT.0.D0)GOTO30
	XRIGHT=X
	VALR=VALL
  20    CONTINUE
C ROOT IS LOCATED, FIND IT
  30    XROOT=(VALL*XRIGHT-VALR*XLEFT)/(VALL-VALR)
	VAL=A-B*LOG(XROOT)+XROOT**2
C Check out for exit
	IF(ABS(VAL).LE.ACCU)THEN
	ROOT=XROOT
	RETURN
	ENDIF
C Root from the right
	IF(VAL.LT.0.D0)THEN
	XLEFT=XROOT
	VALL=VAL
C Root from the left
	ELSEIF(VAL.GT.0.D0)THEN
	XRIGHT=XROOT
	VALR=VAL
	ENDIF
	GOTO 30
	END


	SUBROUTINE GAROOT1(RTOG,CUT,S,L1,L2,ROOT)
************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	DATA ACCU/1.D-10/
	XMAX=20.D0
  10    VAL=LOG(RTOG)+DBLE(L2)*LOG(CUT/2.D0/XMAX)-
     &  (CUT/2.D0/XMAX)**2-DBLE(L1)*LOG(S*XMAX)+(S*XMAX)**2
	IF(VAL.LT.0.D0)XMAX=XMAX*2.D0
	IF(VAL.LT.0.D0)GOTO10
	DO 20 X=XMAX,ACCU,-0.01D0
	VALL=LOG(RTOG)+DBLE(L2)*LOG(CUT/2.D0/X)-
     &  (CUT/2.D0/X)**2-DBLE(L1)*LOG(S*X)+(S*X)**2
	IF(VALL.LT.0.D0)XLEFT=X
	IF(VALL.LT.0.D0)GOTO30
	XRIGHT=X
	VALR=VALL
  20    CONTINUE
	STOP' NO ROOT FOUND IN <GAROOT>'
C ROOT IS LOCATED, FIND IT
  30    XROOT=(VALL*XRIGHT-VALR*XLEFT)/(VALL-VALR)
	VAL=LOG(RTOG)+DBLE(L2)*LOG(CUT/2.D0/XROOT)-
     &  (CUT/2.D0/XROOT)**2-DBLE(L1)*LOG(S*XROOT)+(S*XROOT)**2
C Check out for exit
	IF(ABS(VAL).LE.ACCU)THEN
	ROOT=XROOT
	RETURN
	ENDIF
C Root from the right
	IF(VAL.LT.0.D0)THEN
	XLEFT=XROOT
	VALL=VAL
C Root from the left
	ELSEIF(VAL.GT.0.D0)THEN
	XRIGHT=XROOT
	VALR=VAL
	ENDIF
	GOTO 30
	END

