	SUBROUTINE SETUP
*************************************************************
*  Sets up default control parameters, variables, etc.      *
*************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
        CHARACTER TXTEL(NSORTMAX)*10,TXTSP(2)*2,TXTSCR*60
        COMMON /CONTROL/ LIFT,LMTO,NCOU,NOVR,NPFR !!! control settings
	COMMON /COMCENY/ NENY,EPSTNY,STEPE        !!! search_of_eny
	COMMON /COMFERM/ NFERMI,EPSFERMI,HFERMI   !!! search_of_ef
        COMMON /ACCU/    EPSTOT,EPSRHO,EPSMAG     !!! accuracy
	COMMON /MASHEPS/ EPSMAS                   !!! mashine accuracy
        COMMON /SCRDIR/  TXTSCR                   !!! path to scratch files
	COMMON /WORD/    NVAL                     !!! record length value
        COMMON /TXTEL/   TXTEL,TXTSP              !!! spin labels
	COMMON /UNIT/    IUN,IUT,IUR              !!! output&input channels
*  DEFAULT CONTROL SETTINGS
	NOVR=2          ! always do overlap matrix via S-dot
*  DIFFERENT INITIALISATIONS FOR PROGRAM:
	NENY=100        ! max. number of iterations in search eny
	EPSTNY= 1.D-10  ! accuracy in search eny
	STEPE= 0.5D0    ! init. step in search of eny
	NFERMI=100      ! number of iterations in search ef
	EPSFERMI=1.D-9  ! accuracy  in search ef
	HFERMI=0.8D0    ! initial step in search ef
        TXTSP(1)='up'   ! UP spin label
        TXTSP(2)='dn'   ! DOWN spin label
        EPSTOT=0.D0     ! Total energy accuracy (reads from INIFILE)
        EPSRHO=1.D-10   ! Charge density accuracy
        EPSMAG=1.D-10   ! Magnetization accuracy
*  DATA DEPENDING ON THE COMPUTER:
* 1) Record lenght value for unformatted output
	NVAL=16         ! IBM RISC value
*       NVAL=4          ! DEC VAX  value 
*       NVAL=16         ! CRAY value 
*       NVAL=16         ! MS-DOS FTN77/486 value
* 2) Mashine accuracy
        EPSMAS=1.D-15
*  DEFAULT OUTPUT CHANNELS
	IUN=6           ! default channel to store the data
	IUT=6           ! channel tp print  on the terminal
        IUR=5           ! channel to read from the terminal
*  PATH TO SCRATCH DIRECTORY
	TXTSCR='/scratch/'
	END
