        SUBROUTINE VECLIST
***********************************************************
*  Generates coordination spheres in reciprocal space     *
***********************************************************
        IMPLICIT REAL*8 (A-H,O-Z)
        INCLUDE 'PARAM.DAT'
        INTEGER IS(NPAT),ILST(NSORTMAX),ILSB(NSORTMAX)
     &   ,INDG(NFFTMAX),KVEC(3,0:NPLWMAX),KGMIN(3),KGMAX(3)
     &   ,ILSV(NSORTMAX),NFFTG(3),IKOV(NOPRMAX),IP(NPAT,NOPRMAX)
     &   ,INDRSH(0:NPLWMAX),INPTBR(NOPRMAX,NENVMAX)
        DIMENSION RBAS(3,3),GBAS(3,3),TAU(3,NPAT),ORTH(2:3)
     &   ,GPLW(3,0:NPLWMAX),GL(3),SMT(NSORTMAX)
     &   ,RDC(3,NPAT,NOPRMAX),SHIFT(3,NOPRMAX)
        COMPLEX*16 U(NWIGMAX,48)
	LOGICAL EXIST
C Controls:
        COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM         !!! from init
C Inputs:
        COMMON /LATTICE/RBAS,GBAS                             !!! from init
        COMMON /BASIS/  TAU                                   !!! from init
        COMMON /POTCOM/ SWZ,SMT                               !!! from init
        COMMON /LATPAR/ PAR,ORTH,OMEGAC                       !!! from init
C Plane waves:
        COMMON /PLWMESH/NPLW,GPLW,KVEC,KGMIN,KGMAX,INDG       !!! from plwmsh
        COMMON /FFTMESH/NFFTG                                 !!! from init
C Group:
        COMMON /INVERS/ INV,IKOV                              !!! from group
        COMMON /GROUPOUT/NGROUP,U,IP,RDC,SHIFT                !!! from group
C Outputs:
        COMMON /WORD/   NVAL                                  !!! from nmtdata
        COMMON /UNIT/   IUN,IUT,IUR,IUNOUT                    !!! from init
        DATA PI/3.141592653589793D0/
	CALL PLWMSH
	WRITE(IUT,1010)
1010	FORMAT(1X,$,'Enter # of coordination spheres for G-vecs.? ')
	READ(IUR,*)NRSH
C  SET INDICATOR ARRAY TO ZERO
        DO IPLW=0,NPLW
        INDRSH(IPLW)=0
	ENDDO
        IRSH=0
C  DO OVER PLANE WAVES
        DO 30 IPLW=1,NPLW                           !!! over iplw
        IF(INDRSH(IPLW).NE.0)GOTO30
        IRSH=IRSH+1
C  RECIPROCAL LATTICE VECTOR IS GIVEN BY
        GX=GPLW(1,IPLW)
        GY=GPLW(2,IPLW)
        GZ=GPLW(3,IPLW)
        GRSH=SQRT(GPLW(1,IPLW)**2+GPLW(2,IPLW)**2+GPLW(3,IPLW)**2)
        DO IR=1,NGROUP                              !!! over point group
C  APPLY SYMMETRY OPERATION
        IG=IKOV(IR)
        CALL ROTATE(GX,GY,GZ,GRX,GRY,GRZ,U(2,IG),2)
C  GET COORDINATES IN G1,G2,G3
        X1R=GRX*RBAS(1,1)+GRY*RBAS(2,1)+GRZ*RBAS(3,1)
        X2R=GRX*RBAS(1,2)+GRY*RBAS(2,2)+GRZ*RBAS(3,2)
        X3R=GRX*RBAS(1,3)+GRY*RBAS(2,3)+GRZ*RBAS(3,3)
        M1R=ANINT(X1R)
        M2R=ANINT(X2R)
        M3R=ANINT(X3R)
        IF(ABS(DBLE(M1R)-X1R).GE.1.D-10.OR.
     &     ABS(DBLE(M2R)-X2R).GE.1.D-10.OR.
     &     ABS(DBLE(M3R)-X3R).GE.1.D-10)STOP'<TTRINT2>: WRONG VECTOR'
        IDIM=1+M1R-KGMIN(1)+(KGMAX(1)-KGMIN(1)+1)*(M2R-KGMIN(2))+
     &  (KGMAX(1)-KGMIN(1)+1)*(KGMAX(2)-KGMIN(2)+1)*(M3R-KGMIN(3))
        IPLWR=INDG(IDIM)
        IF(IPLWR.EQ.-1)STOP'<PLWCRD>:: ERROR IN IPLWR'
        INDRSH(IPLWR)=IRSH
        ENDDO                                        !!! over group
  30    CONTINUE                                     !!! over iplw
        NRSHTOT=IRSH                                 !!! total # of shells
C  PRINT COORDINATION SPHERES IN RECIPROCAL SPACE
	WRITE(IUNOUT,1100)
	WRITE(IUNOUT,1110)
	DO IRSH=0,NRSH                  
	IPWS=0
	DO IPLW=0,NPLW
	IF(INDRSH(IPLW).EQ.IRSH)THEN
	PX=GPLW(1,IPLW)
	PY=GPLW(2,IPLW)
	PZ=GPLW(3,IPLW)
	GP=SQRT(PX**2+PY**2+PZ**2)
	IPWS=IPWS+1
	ENDIF
        ENDDO   
	DO IPLW=0,NPLW
	IF(INDRSH(IPLW).EQ.IRSH)
     &	WRITE(IUNOUT,1120)IPLW,GPLW(1,IPLW),GPLW(2,IPLW),
     &  GPLW(3,IPLW),GP,IRSH,IPWS
	ENDDO 
	ENDDO
	CLOSE(UNIT=IUNOUT)
1100    FORMAT(1X,7('*'),' Coord. shells in reciprocal  lattice :',
     &  28('*'))
1110    FORMAT(1X,'Iplw:',3X,'Reciprocal lattice vecs  (units 2pi/a):',
     &  30X,'Lenght',5X,' S#  Nv')
1120    FORMAT(1X,I4,1X,G21.14,1X,G21.14,1X,G21.14,
     &  2X,G13.6,4X,I2,2X,I2)
        RETURN
        END
