	SUBROUTINE DELMSH
**************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER ISG(NOPRMAX,NOPRMAX),MSYMPN(NOPRMAX,KMAX)
     &   ,KQG(3,NOPRMAX),IKOV(NOPRMAX)
	DIMENSION QPNT(3),RBAS(3,3),GBAS(3,3)
     &   ,QB(3,3),RB(3,3)
	COMPLEX*16 U(NWIGMAX,48)
	LOGICAL FIRST
	COMMON /LATTICE/  RBAS,GBAS,QB,RB                      !!! from init
	COMMON /QMESH/    NQPNT,QPNT                           !!! from init
	COMMON /INVERS/   INV,IKOV                             !!! from group
	COMMON /GROUPOUT/ NGROUP,U                             !!! from group
	COMMON /SUBGROUP/ NSGQ,NGEQ,ISG,KSYMPN,MSYMPN,IGS      !!! from symmsh
	COMMON /UNIT/     IUN                                  !!! from init
	DATA FIRST/.TRUE./,PI/3.141592653589793D0/
C  ROTATE Q-VECTOR BY RECIPROCAL SYMMETRY OPERATIONS
	DO 10 IR=1,NGROUP                               !!! over group
	IG=IKOV(IR)
	CALL ROTATE(QPNT(1),QPNT(2),QPNT(3),Q1,Q2,Q3,
     &  U(2,IG),1)
	X1=Q1*RB(1,1)+Q2*RB(2,1)+Q3*RB(3,1)
	X2=Q1*RB(1,2)+Q2*RB(2,2)+Q3*RB(3,2)
	X3=Q1*RB(1,3)+Q2*RB(2,3)+Q3*RB(3,3)
	J1=ANINT(X1)
	J2=ANINT(X2)
	J3=ANINT(X3)
C  CHECK WHETHER THE Q-VECTOR IS IN THE MESH
	IF(ABS(X1-J1).GE.1.D-05.OR.ABS(X2-J2).GE.1.D-05.OR.ABS(X3-J3).
     &  GE.1.D-05)STOP'<DELMSH>: Q-COORDINATES ARE NOT INTEGER'
	KQG(1,IR)=J1
	KQG(2,IR)=J2
	KQG(3,IR)=J3
  10    CONTINUE                                       !!! over group
C  DEFINE # OF ELEMENTS IN Q-STAR
	NSGQ=0
	NGEQ=0
	DO 60 IR=1,NGROUP
	NEC=1
	DO 30 ISGQ=1,NSGQ
	DO 20 IGEQ=1,NGEQ
	IF(ISG(IGEQ,ISGQ).EQ.IR)NEC=0
  20    CONTINUE
  30    CONTINUE
	IF(NEC.EQ.1)THEN
	NSGQ=NSGQ+1
	NGEQ=0
	DO 50 IR1=IR,NGROUP                            !!! over group
	NEQ=0
	DO 40 I=1,3
	IF(KQG(I,IR).EQ.KQG(I,IR1))NEQ=NEQ+1
  40    CONTINUE
	IF(NEQ.EQ.3)THEN
	NGEQ=NGEQ+1
	ISG(NGEQ,NSGQ)=IR1
	ENDIF
  50    CONTINUE                                       !!! over group
	ENDIF
  60    CONTINUE
	WRITE(IUN,1010)(QPNT(I),I=1,3)
	WRITE(IUN,1020) NGEQ
	WRITE(IUN,1030) NSGQ
1010    FORMAT(1X,'Symmetry analysis for q = (',G11.4,',',G11.4,','
     & ,G11.4,')')
1020    FORMAT(1X,'1) group of q-vector contains ',I2,' elements')
1030    FORMAT(1X,'2) star  of q-vector contains ',I2,' elements')
	END
