	SUBROUTINE SVECGEN
***********************************************************
*  Generate vectors in direct and reciprocal space using  *
*  STRPAC. S.Savrasov, Last revison 29.11.92.             *
***********************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	PARAMETER (NDTMAX=NPAT*NPAT)
	INTEGER IS(NPAT),ILST(NSORTMAX),ILSB(NSORTMAX)
     &   ,ILSV(NSORTMAX),NHSORT(NSORTMAX),IREF(NVCMAX*NPAT)
     &   ,IDELP(NPAT,NPAT),ILS2(NDTMAX),ILS4(NDTMAX),LIMLPL2(NDTMAX)
     &   ,LIMLPL4(NDTMAX),ILD2(NDTMAX),ILD4(NDTMAX),LIMLDL2(NDTMAX)
     &   ,LIMLDL4(NDTMAX),NKAP(NPANMAX)
	DIMENSION RBAS(3,3),GBAS(3,3),RVEC(3,NVCMAX),TAU(3,NPAT)
     &   ,GVEC(3,NVCMAX),DELTAU(3,NDTMAX),GL(3),TAU0(3),SVEC(3,NVCMAX)
     &   ,PNT(3,KMAX)
	COMPLEX*16 EKAP(NKAPMAX,NPANMAX),EK(NKAPMAX,NPANMAX)
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM,NHSORT    !!! from init
	COMMON /LATTICE/RBAS,GBAS                               !!! from init
	COMMON /BASIS/  TAU                                     !!! from init
	COMMON /KAPPAR/ NPAN,NKAP,EK,EKAP,EDGE                  !!! from vecgen
	COMMON /STRINP/ NVEC,ALPHA                              !!! from init
	COMMON /VECGEN/ LIMDT,DELTAU,NRVEC,RVEC,NGVEC,GVEC,ETA  !!! from vecgen
     &                 ,NSVEC,SVEC
	COMMON /LM2STR/ IDELP,NR2,ILS2,ILD2,LIMLPL2,LIMLDL2     !!! from vecgen
	COMMON /LM4STR/       NR4,ILS4,ILD4,LIMLPL4,LIMLDL4     !!! from vecgen
	COMMON /MESH/   NPNT,PNT                                !!! from ttrmsh
	COMMON /LATPAR/ PAR                                     !!! from init
	COMMON /UNIT/   IUN                                     !!! from init
	COMMON /WORD/   NVAL                                    !!! from nmtdata
	DATA PI/3.141592653589793D0/,TAU0/0.D0,0.D0,0.D0/
	IF(NVEC.GT.NVCMAX)STOP'TOO MANY VECTORS IN <VECGEN>,
     &  INCREASE NVCMAX IN PARAM.DAT'
C  INPUT # = NVEC, SET UP ACCURACY, EPS=EXP(-ACCU*ACCU) 
	ACCU=(3.D0*SQRT(PI)/4.D0*DBLE(NVEC))**(1.D0/3.D0)
C  SET UP # OF VECTORS FROM THE CONDITION OF FASTEST CALCULATION
C  WITH THE FIXED ACCURACY "ACCU". TIME UNITS=SPH.HARM.CALCULATION
C       TIMED=DBLE(NATOM)**2*(NKAP(1)+3.D0*NKAP(1)+1.D0)
C       TIMER=DBLE(NATOM)**2*(NKAP(1)+1.D0/DBLE(NATOM))
	XN=4.D0    !!! UNIVERSAL; XN=TIMED/TIMER, SEE ABOVE FORMULAS 
	IF(NATOM.EQ.1.AND.NKAP(1).EQ.1)XN=2.5D0 ! SEE ABOVE FORMULAS
	XN=XN*ALPHA
	NG=AINT(DBLE(NVEC)*SQRT(XN))
	NR=AINT(DBLE(NVEC)/SQRT(XN))
C  DEFINE SUMMATION SPHERES
	CALL CROSS(GL,RBAS(1,2),RBAS(1,3))
	OMEGAR=ABS(RBAS(1,1)*GL(1)+RBAS(2,1)*GL(2)+RBAS(3,1)*GL(3)) 
	RMAXR=(3.D0*DBLE(NR)*OMEGAR/4.D0/PI)**(1.D0/3.D0)+1.D-04
	CALL CROSS(GL,GBAS(1,2),GBAS(1,3))
	OMEGAG=ABS(GBAS(1,1)*GL(1)+GBAS(2,1)*GL(2)+GBAS(3,1)*GL(3)) 
	RMAXG=(3.D0*DBLE(NG)*OMEGAG/4.D0/PI)**(1.D0/3.D0)+1.D-04
C  GENERATE DIRECT AND RECIPROCAL LATTICE VECTORS
	CALL SITEGEN(RMAXR,RBAS(1,1),RBAS(1,2),RBAS(1,3),TAU0,1,
     &  NRVEC,RVEC,IREF)
	CALL SITEGEN(RMAXG,GBAS(1,1),GBAS(1,2),GBAS(1,3),TAU0,1,
     &  NGVEC,GVEC,IREF)
C  SET UP EVALD SPLITTING ETA
	ETA0=SQRT(PI)/OMEGAR**(1.D0/3.D0)
	ETA=ETA0*XN**(1.D0/6.D0)
C  SET UP # OF VECTORS FOR DIRECT SUMMATION
	RMAXS=(3.D0*DBLE(NR+NG)*OMEGAR/4.D0/PI)**(1.D0/3.D0)+1.D-04
	CALL SITEGEN(RMAXS,RBAS(1,1),RBAS(1,2),RBAS(1,3),TAU0,1,
     &  NSVEC,SVEC,IREF)
	EDGE=-ACCU**4/RMAXS**2/PAR**2
C  FIND CONNECTING VECTORS
	LIMDT=0
	DELMAX=0.D0
	DO 40 IATOM=1,NATOM
	DO 30 JATOM=1,NATOM
	GL(1)=TAU(1,IATOM)-TAU(1,JATOM)
	GL(2)=TAU(2,IATOM)-TAU(2,JATOM)
	GL(3)=TAU(3,IATOM)-TAU(3,JATOM)
	DO 10 IDT=1,LIMDT
	IF(ABS(GL(1)-DELTAU(1,IDT)).LE.1.D-10.AND
     &    .ABS(GL(2)-DELTAU(2,IDT)).LE.1.D-10.AND
     &    .ABS(GL(3)-DELTAU(3,IDT)).LE.1.D-10)GOTO20
  10    CONTINUE
	LIMDT=LIMDT+1
	DELTAU(1,LIMDT)=GL(1)
	DELTAU(2,LIMDT)=GL(2)
	DELTAU(3,LIMDT)=GL(3)
	CALL REDUC2(GL(1),GL(2),GL(3),NRVEC,RVEC,DRX,DRY,DRZ,RX,RY,RZ)
	DELMAX=MAX(DELMAX,SQRT(DRX*DRX+DRY*DRY+DRZ*DRZ))
	IDELP(IATOM,JATOM)=LIMDT
	GOTO 30
  20    IDELP(IATOM,JATOM)=IDT
  30    CONTINUE
  40    CONTINUE
C  FIND MAX.LMAX FOR CONNECTING VECTORS
	ILS2MAX=0
	ILS4MAX=0
	DO 70 IDT=1,LIMDT
	ILS2(IDT)=0
	ILD2(IDT)=0
	ILS4(IDT)=0
	ILD4(IDT)=-1
	DO 60 IATOM=1,NATOM
	DO 50 JATOM=1,NATOM
	IF(IDELP(IATOM,JATOM).EQ.IDT)THEN
	LS2=1+ILST(IS(IATOM))+ILSB(IS(JATOM))
	LD2=1+ILSB(IS(IATOM))+ILSB(IS(JATOM))
	LS4=ILSV(IS(IATOM))+ILSV(IS(JATOM))+2
	LD4=-1
	ILS2(IDT)=MAX(ILS2(IDT),LS2)
	ILD2(IDT)=MAX(ILD2(IDT),LD2)
	ILS4(IDT)=MAX(ILS4(IDT),LS4)
	ILD4(IDT)=MAX(ILD4(IDT),LD4)
	ILS2MAX=MAX(ILS2MAX,ILS2(IDT))
	ILS4MAX=MAX(ILS4MAX,ILS4(IDT))
	ENDIF
  50    CONTINUE
  60    CONTINUE
	LIMLPL2(IDT)=(ILS2(IDT)+1)**2
	LIMLDL2(IDT)=(ILD2(IDT)+1)**2
	LIMLPL4(IDT)=(ILS4(IDT)+1)**2
	LIMLDL4(IDT)=(ILD4(IDT)+1)**2
  70    CONTINUE
C  ESTIMATE RECORD LENGHT FOR STR.CON
	LIM2=0
	LIM4=0
	DO 80 ITAU=1,LIMDT
	LIM2=MAX(LIM2,LIMLPL2(ITAU)+LIMLDL2(ITAU))
	LIM4=MAX(LIM4,LIMLPL4(ITAU))
  80    CONTINUE
	NR2=LIM2*NVAL+NVAL/2+NVAL/2
	NR4=LIM4*NVAL+NVAL/2
C  DEFINE MAXIMAL K-VECTOR
	PNTMAX=0.D0
	DO 90  IPNT=1,NPNT
	CALL REDUC2(PNT(1,IPNT),PNT(2,IPNT),PNT(3,IPNT),
     &  NGVEC,GVEC,XK,YK,ZK,GX,GY,GZ)
	PNTMAX=MAX(PNTMAX,SQRT(XK*XK+YK*YK+ZK*ZK))
  90    CONTINUE
C  PRINT CALCULATED VALUES
	EPSR=EXP(-(RMAXR**2+DELMAX**2-2.D0*RMAXR*DELMAX)*ETA*ETA)
	EPSG=EXP(-(RMAXG**2+PNTMAX**2-2.D0*RMAXG*PNTMAX)/ETA/ETA/4.D0*
     &  (2.D0*PI)**2) 
	EPSS=EXP(-(RMAXS**2+DELMAX**2-2.D0*RMAXS*DELMAX)**0.5D0*
     &  SQRT(-EDGE)*PAR)
	WRITE(IUN,1010)
	WRITE(IUN,1020)RMAXR,EPSR,NRVEC
	WRITE(IUN,1030)RMAXG,EPSG,NGVEC
	WRITE(IUN,1040)RMAXS,EPSS,NSVEC
	WRITE(IUN,1050)EDGE
	WRITE(IUN,1060)LIMDT
1010   FORMAT(1X,'Result from VECGEN for direct/reciprocal spaces --->')
1020   FORMAT(1X,'Rmax=',G14.7,'; Accuracy=',G14.7,'; # of vectors=',I6)
1030   FORMAT(1X,'Gmax=',G14.7,'; Accuracy=',G14.7,'; # of vectors=',I6)
1040   FORMAT(1X,'Smax=',G14.7,'; Accuracy=',G14.7,'; # of vectors=',I6)
1050   FORMAT(1X,'Min.energy for using Evald"s method=',G14.7,' Ry')
1060   FORMAT(1X,'Total # of connecting vectors found ',I7)
	END






	SUBROUTINE CROSS(A,B,C)
**********************************************************
*    Cross product (AX,AY,AZ)=(BX,BY,BZ)*(CX,CY,CZ)      *
**********************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	DIMENSION A(3),B(3),C(3)
	A(1)=B(2)*C(3)-B(3)*C(2)
	A(2)=B(3)*C(1)-B(1)*C(3)
	A(3)=B(1)*C(2)-B(2)*C(1)
	RETURN
	END



	SUBROUTINE REDUC2(DX,DY,DZ,NVEC,VEC,DRX,DRY,DRZ,RX,RY,RZ)
*****************************************************************
*  Represents vector D as Dr-R, where Dr has a minimal lenght   *
*  and R is one of the lattice vectors VEC.                     *
*****************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	DIMENSION VEC(3,NVEC)
	DRX=DX
	DRY=DY
	DRZ=DZ
	ABSDR=SQRT(DRX*DRX+DRY*DRY+DRZ*DRZ)
	RX=0.D0
	RY=0.D0
	RZ=0.D0
	DO 10 IVEC=1,NVEC
	TRX=DX+VEC(1,IVEC)
	TRY=DY+VEC(2,IVEC)
	TRZ=DZ+VEC(3,IVEC)
	ABSTR=SQRT(TRX*TRX+TRY*TRY+TRZ*TRZ)
	IF(ABSTR.GE.ABSDR)GOTO10
	DRX=TRX
	DRY=TRY
	DRZ=TRZ
	ABSDR=ABSTR
	RX=VEC(1,IVEC)
	RY=VEC(2,IVEC)
	RZ=VEC(3,IVEC)
  10    CONTINUE
	END
